<?php
/**
*
* @package DM Easy Download System
* @version $Id: acp_dm_eds.php 156 2009-11-19 12:06:23Z femu $
* @copyright (c) 2009 femu - http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* Here we start the ACP panel
*/
class acp_dm_eds
{
	var $u_action;
	function main($id, $mode)
	{
		// Let's first set some globals, includes, variables and the base template
		global $db, $user, $phpbb_root_path, $phpbb_admin_path, $phpEx, $template, $u_action, $cache, $config;
		global $dm_eds_root_path, $dm_eds_file_path, $phpbb_root_path, $phpEx;
		$dm_eds_root_path = DM_EDS_ROOT_PATH;
		$dm_eds_file_path = DM_EDS_FILE_PATH;
		include($phpbb_root_path . $dm_eds_root_path . 'includes/functions_acp_dm_eds.' . $phpEx);
		include($phpbb_root_path . 'includes/functions_upload.' . $phpEx);

		$user->add_lang('posting');
		
		$action = request_var('action', '');
		$id		= request_var('id', 0);
		$form_action = $this->u_action. '&amp;action=add';
		$lang_mode = $user->lang['ACP_ADD'];

		// Read out config table
		$sql = 'SELECT * 
			FROM ' . DM_EDS_CONFIG_TABLE;
		$result = $db->sql_query($sql);
		$eds_values = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		$start	= request_var('start', 0);
		$number	= $eds_values['pagination_acp'];

		$template->assign_vars(array(
			'BASE'	=> $this->u_action,
		));

		// Here we set the main switches to use within the ACP
		switch ($mode)
		{
			// Set the main switch for managing categories
			case 'config':
				$this->page_title = 'ACP_MANAGE_CONFIG';
				$this->tpl_name = 'acp_dm_eds_config';

				$sql = 'SELECT * 
					FROM ' . DM_EDS_CONFIG_TABLE;
				$result = $db->sql_query($sql);
				$eds_values = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
				
				$set_pagination = (isset($_POST['action_set_pagination'])) ? true : false;

				if ( $set_pagination )
				{
					// Values for eds_config
					$sql_ary = array (
						'pagination_acp'	=> request_var('pagination_acp', 0),
						'pagination_user'	=> request_var('pagination_user', 0),
						'announce_enable'	=> request_var('announce_enable', 0),
						'announce_forum'	=> request_var('announce_forum', 0),
					);

					// Check if pagination_acp is at least 5
					$check_acp = request_var('pagination_acp', 0);
					if ( $check_acp < 5 )
					{
						trigger_error($user->lang['ACP_PAGINATION_ERROR_ACP'] . adm_back_link($this->u_action), E_USER_WARNING);
					}

					// Check if pagination_acp is at least 5
					$check_user = request_var('pagination_user', 0);
					if ( $check_user < 3 )
					{
						trigger_error($user->lang['ACP_PAGINATION_ERROR_USER'] . adm_back_link($this->u_action), E_USER_WARNING);
					}

					// Check if announce forum id exists
					if ( request_var('announce_enable', 0) == 1 )
					{
						$check_forum_id = request_var('announce_forum', 0);
						$sql = 'SELECT *
							FROM ' . FORUMS_TABLE . '
							WHERE forum_id = ' . $check_forum_id;
						$result = $db->sql_query($sql);
						$check_id = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);
						
						if ( empty($check_id) )
						{
							trigger_error($user->lang['ACP_FORUM_ID_ERROR'] . adm_back_link($this->u_action), E_USER_WARNING);
						}
					}

					// Update values in phpbb_points_values
					$sql = 'UPDATE ' . DM_EDS_CONFIG_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary);
					$db->sql_query($sql);

					trigger_error($user->lang['ACP_CONFIG_SUCCESS'] . adm_back_link($this->u_action));
				}
				else 
				{
					$template->assign_vars(array(
						'PAGINATION_ACP'	=> $eds_values['pagination_acp'],
						'PAGINATION_USER'	=> $eds_values['pagination_user'],
						'ANNOUNCE_ENABLE'	=> $eds_values['announce_enable'],
						'ANNOUNCE_FORUM'	=> $eds_values['announce_forum'],
						'U_BACK'			=> $this->u_action,
						'U_ACTION'			=> $form_action,
					));
				}

				// If UPS installed set points general
				if ( defined('IN_ULTIMATE_POINTS') )
				{
					$template->assign_vars(array(
						'S_POINTS_ENABLED'	=> true,
					));
				
					$set_points = (isset($_POST['action_set_points'])) ? true : false;

					if ( $set_points )
					{
						$sql_ary = array (
							'costs_per_dl'	=> round(request_var('costs_per_dl', 0.00),2),
						);

						// Update values in phpbb_points_values
						$sql = 'UPDATE ' . DM_EDS_CONFIG_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary);
						$db->sql_query($sql);

						trigger_error($user->lang['ACP_CONFIG_SUCCESS'] . adm_back_link($this->u_action));
					}
					else
					{
						$template->assign_vars(array(
							'POINTS_NAME'	=> $config['points_name'],
							'COSTS_PER_DL'	=> $eds_values['costs_per_dl'],
							'U_BACK'		=> $this->u_action,
							'U_ACTION'		=> $form_action,
						));
					}
				}

				// If UPS installed set points value for all downloads
				if ( defined('IN_ULTIMATE_POINTS') )
				{
					$template->assign_vars(array(
						'S_POINTS_ENABLED'	=> true,
					));
				
					$set_points = request_var('action_set_points_all', '');

					if ( $set_points )
					{
						if (confirm_box(true))
						{
							$sql_ary = array (
								'cost_per_dl'	=> round(request_var('cost_per_dl', 0.00),2),
							);

							// Update values in downloads
							$sql = 'UPDATE ' . DM_EDS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary);
							$db->sql_query($sql);

							trigger_error($user->lang['ACP_UPS_SUCCESS'] . adm_back_link($this->u_action));
						}
						// Create a confirmbox with yes and no.
						else
						{
							$s_hidden_fields = build_hidden_fields(array(
								'cost_per_dl'			=> request_var('cost_per_dl', 0.00),
								'action'				=> $action,
								'action_set_points_all'	=> true,
								)
							);

							// Display mode
							confirm_box(false, $user->lang['ACP_UPS_SET_POINTS_CONFIRM'], $s_hidden_fields);
						}
					}
					else
					{
						$template->assign_vars(array(
							'POINTS_NAME'	=> $config['points_name'],
							'COSTS_PER_DL'	=> $eds_values['costs_per_dl'],
							'U_BACK'		=> $this->u_action,
							'U_ACTION'		=> $form_action,
						));
					}
				}
			break;

			case 'categories':
				$this->page_title = 'ACP_MANAGE_CATEGORIES';
				$this->tpl_name = 'acp_dm_eds';

				// Now let's define, what to do within the module Manage Categories
				switch ($action)
				{
					// Create a new category
					case 'create':
						$title = 'ACP_NEW_CAT';
						$this->page_title = $user->lang[$title];

						$this->create_cat();
					break;

					// Edit an existing category
					case 'edit':
						$title = 'ACP_EDIT_CAT';
						$this->page_title = $user->lang[$title];

						$this->edit_cat();
					break;
					// Delete an existing category
					case 'delete':
						$title = 'ACP_DEL_CAT';
						$this->page_title = $user->lang[$title];

						$this->delete_cat();
					break;

					// Move a category to another position
					case 'move':
						$this->move_cat();
					break;

					// Call the main module
					default:
						$title = 'ACP_MANAGE_CATEGORIES';
						$this->page_title = $user->lang[$title];

						$this->manage_cats();
					break;
				}
			break;

			// Set the main switch for editing downloads
			case 'downloads':
				$this->page_title = 'ACP_EDIT_DOWNLOADS';
				$this->tpl_name = 'acp_dm_eds_list';

				if ( defined('IN_ULTIMATE_POINTS') )
				{
					$template->assign_vars(array(
						'S_UPS_EXIST'	=> true,
					));
				}

				$sort_days	= request_var('st', 0);
				$sort_key	= request_var('sk', 'download_title');
				$sort_dir	= request_var('sd', 'ASC');
				$limit_days = array(0 => $user->lang['ACP_ALL_DOWNLOADS'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);

				$sort_by_text = array('t' => $user->lang['ACP_SORT_TITLE'], 'c' => $user->lang['ACP_SORT_CAT']);
				$sort_by_sql = array('t' => 'download_title', 'c' => 'cat_name');

				$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
				gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);
				$sql_sort_order = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

				// Total number of downloads
				$sql = 'SELECT COUNT(download_id) AS total_downloads
					FROM ' . DM_EDS_TABLE;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$total_downloads = $row['total_downloads'];
				$db->sql_freeresult($result);

				// List all downloads
				$sql = 'SELECT d.*, c.*
					FROM ' . DM_EDS_TABLE . ' d
					LEFT JOIN ' . DM_EDS_CAT_TABLE . ' c
						ON d.download_cat_id = c.cat_id
					ORDER BY '. $sql_sort_order;
				$result = $db->sql_query_limit($sql, $number, $start);

				while ($row = $db->sql_fetchrow($result))
				{
					$template->assign_block_vars('downloads', array(
						'ICON_COPY'		=> '<img src="' . $phpbb_admin_path . 'images/file_new.gif" alt="' . $user->lang['ACP_COPY_NEW'] . '" title="' . $user->lang['ACP_COPY_NEW'] . '" />',

						'TITLE'			=> $row['download_title'],
						'FILENAME'		=> $row['download_filename'],
						'DESC'			=> generate_text_for_display($row['download_desc'], $row['bbcode_uid'], $row['bbcode_bitfield'], $row['bbcode_options']),
						'VERSION'		=> $row['download_version'],
						'DL_COST'		=> ($row['cost_per_dl'] == 0 ? $user->lang['ACP_COST_FREE'] : $row['cost_per_dl']),
						'SUB_DIR'		=> $row['cat_sub_dir'],
						'CATNAME'		=> $row['cat_name'],
						'U_COPY'		=> $this->u_action . '&amp;action=copy_new&amp;id=' .$row['download_id'],
						'U_EDIT'		=> $this->u_action . '&amp;action=edit&amp;id=' .$row['download_id'],
						'U_DEL'			=> $this->u_action . '&amp;action=delete&amp;id=' .$row['download_id'],
						)
					);
				}
				$db->sql_freeresult($result);

				$template->assign_vars(array(
					'S_DOWNLOAD_ACTION' => $this->u_action,
					'S_SELECT_SORT_DIR'	=> $s_sort_dir,
					'S_SELECT_SORT_KEY'	=> $s_sort_key,
					'PAGINATION' 		=> generate_pagination($this->u_action . '&amp;sk=' . $sort_key .'&amp;sd=' . $sort_dir, $total_downloads, $number, $start, true),
					'PAGE_NUMBER'		=> on_page($total_downloads, $number, $start),
					'TOTAL_DOWNLOADS'	=> ($total_downloads == 1) ? $user->lang['ACP_SINGLE_DOWNLOAD'] : sprintf($user->lang['ACP_MULTI_DOWNLOAD'], $total_downloads),
					'U_NEW_DOWNLOAD'	=> $this->u_action . '&amp;action=new_download',
					'L_MODE_TITLE'		=> $lang_mode,
					'U_EDIT_ACTION'		=> $this->u_action,
				));

				// Now let's define, what to do within the module Edit Downloads
				switch ($action)
				{
					case 'new_download';
						$this->page_title = 'ACP_NEW_DOWNLOAD';
						$this->tpl_name = 'acp_dm_eds_new';
						$form_action = $this->u_action. '&amp;action=add_new';
						$lang_mode = $user->lang['ACP_NEW_DOWNLOAD'];

						$action = (!isset($_GET['action'])) ? '' : $_GET['action'];
						$action = ((isset($_POST['submit']) && !$_POST['id']) ? 'add' : $action );

						$id			= request_var('id', 0);
						$title		= request_var('title', '', true);
						$filename	= request_var('filename', '', true);
						$desc		= utf8_normalize_nfc(request_var('desc', '', true));
						$dl_version	= request_var('dl_version', '', true);
						$costs_dl	= request_var('cost_per_dl', 0.00);
						$uid = $bitfield = $options = '';
						generate_text_for_storage($desc, $uid, $bitfield, $options);
						$username1 	= request_var('username', '', true);
						$username 	= strtolower($username1);
						$ftp_upload = request_var('ftp_upload', '', true);

						// Select the user data to transfer to
						$sql_array = array(
							'SELECT'    => '*',
							'FROM'      => array(
								USERS_TABLE => 'u',
							),
							'WHERE'		=> 'username_clean = "' . $db->sql_escape(utf8_clean_string($username)) . '"',
						);
						$sql = $db->sql_build_query('SELECT', $sql_array);
						$result = $db->sql_query($sql);
						$transfer_user = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);

						// Check if categories exists
						$sql = 'SELECT COUNT(cat_id) AS total_cats
							FROM ' . DM_EDS_CAT_TABLE;
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$total_cats = $row['total_cats'];
						$db->sql_freeresult($result);

						if ( $total_cats <= 0 )
						{
							trigger_error($user->lang['ACP_NO_CAT'] . adm_back_link($this->u_action), E_USER_WARNING);
						}

						$sql = 'SELECT *
							FROM ' . DM_EDS_CAT_TABLE . '
							ORDER BY LOWER(cat_name)';
						$result = $db->sql_query($sql);
						$cats = array();
						while ($row2 = $db->sql_fetchrow($result))
						{
							$cats[$row2['cat_id']] = array( 
								'cat_title'	=> $row2['cat_name'], 
								'cat_id'	=> $row2['cat_id'],
							);
						}
						$db->sql_freeresult($result);

						$cat_options = '';
						foreach($cats as $key => $value)
						{
							if ($key == $row2['download_cat_id'])
							{
								$cat_options .= '<option value="' . $value['cat_id'] . '" selected="selected">' . $value['cat_title'] . '</option>';
							}
							else
							{
								$cat_options .= '<option value="' . $value['cat_id'] . '">' . $value['cat_title'] . '</option>';
							}
						}

						if ( defined('IN_ULTIMATE_POINTS') )
						{
							$template->assign_vars(array(
								'S_UPS_EXIST'				=> true,
								'POINTS_NAME'				=> $config['points_name'],
								'ACP_COST_EXPLAIN' 			=> sprintf($user->lang['ACP_COST_EXPLAIN'], $config['points_name']),
								'ACP_COST_TITLE_EXPLAIN'	=> sprintf($user->lang['ACP_COST_TITLE_EXPLAIN'], $config['points_name']),
								'U_FIND_USERNAME'			=> append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=searchuser&amp;form=select_user&amp;field=username&amp;select_single=true'),
							));
						}

						$max_filesize = @ini_get('upload_max_filesize');
						$unit = 'MB';

						if (!empty($max_filesize))
						{
							$unit = strtolower(substr($max_filesize, -1, 1));
							$max_filesize = (int) $max_filesize;

							$unit = ($unit == 'k') ? 'KB' : (($unit == 'g') ? 'GB' : 'MB');
						}

						$template->assign_vars(array(
							'ID'				=> $id,
							'TITLE'				=> $title,
							'DESC'				=> $desc,
							'FILENAME'			=> $filename,
							'DL_VERSION'		=> $dl_version,
							'FTP_UPLOAD'		=> $ftp_upload,
							'PARENT_OPTIONS'	=> $cat_options,
							'COST_PER_DL'		=> sprintf(number_format($eds_values['costs_per_dl'], 2, '.', '')),
							'ALLOWED_SIZE'		=> sprintf($user->lang['ACP_NEW_DOWNLOAD_SIZE'], $max_filesize, $unit),

							'U_BACK'			=> $this->u_action,
							'U_ACTION'			=> $form_action,
							'L_MODE_TITLE'		=> $lang_mode,
						));
					break;

					case 'copy_new';
						$this->page_title = 'ACP_NEW_DOWNLOAD';
						$this->tpl_name = 'acp_dm_eds_new_copy';
						$form_action = $this->u_action. '&amp;action=add_new';
						$lang_mode = $user->lang['ACP_NEW_DOWNLOAD'];

						$action = (!isset($_GET['action'])) ? '' : $_GET['action'];
						$action = ((isset($_POST['submit']) && !$_POST['id']) ? 'add' : $action );

						$id			= request_var('id', '');

						$sql = 'SELECT *
							FROM ' . DM_EDS_TABLE . '
							WHERE download_id = ' . $id;
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						decode_message($row['download_desc'], $row['bbcode_uid']);
						$copy_title = $row['download_title'];
						$copy_version = $row['download_version'];
						$copy_desc = $row['download_desc'];
						$copy_costs_dl = $row['cost_per_dl'];
						$db->sql_freeresult($result);

						$id			= request_var('id', 0);
						$title		= request_var('title', '', true);
						$filename	= request_var('filename', '', true);
						$desc		= utf8_normalize_nfc(request_var('desc', '', true));
						$dl_version	= request_var('dl_version', '', true);
						$costs_dl	= request_var('cost_per_dl', 0.00);
						$uid = $bitfield = $options = '';
						generate_text_for_storage($desc, $uid, $bitfield, $options);
						$username1 	= request_var('username', '', true);
						$username 	= strtolower($username1);
						$ftp_upload = request_var('ftp_upload', '', true);

						// Select the user data to transfer to
						$sql_array = array(
							'SELECT'    => '*',
							'FROM'      => array(
								USERS_TABLE => 'u',
							),
							'WHERE'		=> 'username_clean = "' . $db->sql_escape(utf8_clean_string($username)) . '"',
						);
						$sql = $db->sql_build_query('SELECT', $sql_array);
						$result = $db->sql_query($sql);
						$transfer_user = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);

						// Check if categories exists
						$sql = 'SELECT COUNT(cat_id) AS total_cats
							FROM ' . DM_EDS_CAT_TABLE;
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$total_cats = $row['total_cats'];
						$db->sql_freeresult($result);

						if ( $total_cats <= 0 )
						{
							trigger_error($user->lang['ACP_NO_CAT'] . adm_back_link($this->u_action), E_USER_WARNING);
						}

						$sql = 'SELECT *
							FROM ' . DM_EDS_CAT_TABLE . '
							ORDER BY LOWER(cat_name)';
						$result = $db->sql_query($sql);
						$cats = array();
						while ($row2 = $db->sql_fetchrow($result))
						{
							$cats[$row2['cat_id']] = array( 
								'cat_title'	=> $row2['cat_name'], 
								'cat_id'	=> $row2['cat_id'],
							);
						}
						$db->sql_freeresult($result);

						$cat_options = '';
						foreach($cats as $key => $value)
						{
							if ($key == $row2['download_cat_id'])
							{
								$cat_options .= '<option value="' . $value['cat_id'] . '" selected="selected">' . $value['cat_title'] . '</option>';
							}
							else
							{
								$cat_options .= '<option value="' . $value['cat_id'] . '">' . $value['cat_title'] . '</option>';
							}
						}

						if ( defined('IN_ULTIMATE_POINTS') )
						{
							$template->assign_vars(array(
								'S_UPS_EXIST'				=> true,
								'POINTS_NAME'				=> $config['points_name'],
								'ACP_COST_EXPLAIN' 			=> sprintf($user->lang['ACP_COST_EXPLAIN'], $config['points_name']),
								'ACP_COST_TITLE_EXPLAIN'	=> sprintf($user->lang['ACP_COST_TITLE_EXPLAIN'], $config['points_name']),
								'U_FIND_USERNAME'			=> append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=searchuser&amp;form=select_user&amp;field=username&amp;select_single=true'),
							));
						}

						$max_filesize = @ini_get('upload_max_filesize');
						$unit = 'MB';

						if (!empty($max_filesize))
						{
							$unit = strtolower(substr($max_filesize, -1, 1));
							$max_filesize = (int) $max_filesize;

							$unit = ($unit == 'k') ? 'KB' : (($unit == 'g') ? 'GB' : 'MB');
						}

						$template->assign_vars(array(
							'ID'				=> $id,
							'TITLE'				=> $copy_title,
							'DESC'				=> $copy_desc,
							'FILENAME'			=> $filename,
							'FTP_UPLOAD'		=> $ftp_upload,
							'DL_VERSION'		=> $copy_version,
							'PARENT_OPTIONS'	=> $cat_options,
							'COST_PER_DL'		=> sprintf(number_format($eds_values['costs_per_dl'], 2, '.', '')),
							'ALLOWED_SIZE'		=> sprintf($user->lang['ACP_NEW_DOWNLOAD_SIZE'], $max_filesize, $unit),
							'TRANSFER_USER'		=> $username,

							'U_BACK'		=> $this->u_action,
							'U_ACTION'		=> $form_action,
							'L_MODE_TITLE'	=> $lang_mode,
						));
					break;

					case 'add_new':
						$filecheck = $multiplier = '';

						// Read out config values 
						$sql = 'SELECT *
							FROM ' . DM_EDS_CONFIG_TABLE;
						$result = $db->sql_query($sql);
						$eds_values = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);

						//Make SQL Array
						$id			= request_var('id', 0);
						$title		= request_var('title', '', true);
						$filename	= request_var('filename', '', true);
						$desc		= utf8_normalize_nfc(request_var('desc', '', true));
						$dl_version	= request_var('dl_version', '', true);
						$costs_dl	= request_var('cost_per_dl', 0.00, true);
						$cat_option = request_var('parent', '', true);
						$upload_time = time();
						$last_changed_time = time();
						$uid = $bitfield = $options = '';
						$allow_bbcode = $allow_urls = $allow_smilies = true;
						generate_text_for_storage($desc, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);
						$username1 	= request_var('username', '', true);
						$username 	= strtolower($username1);
						$ftp_upload	= request_var('ftp_upload', '', true);

						// Select the user data to transfer to
						$sql_array = array(
							'SELECT'    => '*',
							'FROM'      => array(
								USERS_TABLE => 'u',
							),
							'WHERE'		=> 'username_clean = "' . $db->sql_escape(utf8_clean_string($username)) . '"',
						);
						$sql = $db->sql_build_query('SELECT', $sql_array);
						$result = $db->sql_query($sql);
						$transfer_user = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);
						
						if ( !$transfer_user )
						{
							$transfer_user['user_id'] = 0;
						}

						if ( !$ftp_upload )
						{
							// Check max. allowed filesize from php.ini
							$max_filesize = @ini_get('upload_max_filesize');
							$unit = 'MB';

							if (!empty($max_filesize))
							{
								$unit = strtolower(substr($max_filesize, -1, 1));
								$max_filesize = (int) $max_filesize;

								$unit = ($unit == 'k') ? 'KB' : (($unit == 'g') ? 'GB' : 'MB');
							}
						}

						// Here you can add additional extenstions
						// Always use lower and upper case extensions
						$allowed_extensions = array();
						// Archive extenstions
						$allowed_extensions[] = 'zip';
						$allowed_extensions[] = 'ZIP';
						$allowed_extensions[] = 'rar';
						$allowed_extensions[] = 'RAR';
						$allowed_extensions[] = '7z';
						$allowed_extensions[] = '7Z';
						$allowed_extensions[] = 'ace';
						$allowed_extensions[] = 'ACE';
						$allowed_extensions[] = 'gtar';
						$allowed_extensions[] = 'GTAR';
						$allowed_extensions[] = 'gz';
						$allowed_extensions[] = 'GZ';
						$allowed_extensions[] = 'tar';
						$allowed_extensions[] = 'TAR';
						// Text files
						$allowed_extensions[] = 'txt';
						$allowed_extensions[] = 'TXT';
						// Documents
						$allowed_extensions[] = 'doc';
						$allowed_extensions[] = 'DOC';
						$allowed_extensions[] = 'docx';
						$allowed_extensions[] = 'DOCX';
						$allowed_extensions[] = 'xls';
						$allowed_extensions[] = 'XLS';
						$allowed_extensions[] = 'xlsx';
						$allowed_extensions[] = 'XLSX';
						$allowed_extensions[] = 'ppt';
						$allowed_extensions[] = 'PPT';
						$allowed_extensions[] = 'pptx';
						$allowed_extensions[] = 'PPTX';
						$allowed_extensions[] = 'pdf';
						$allowed_extensions[] = 'PDF';
						// Real Media files
						$allowed_extensions[] = 'ram';
						$allowed_extensions[] = 'RAM';
						$allowed_extensions[] = 'rm';
						$allowed_extensions[] = 'RM';
						// Windows Media files
						$allowed_extensions[] = 'wma';
						$allowed_extensions[] = 'WMA';
						$allowed_extensions[] = 'wmv';
						$allowed_extensions[] = 'WMV';
						// Flash files
						$allowed_extensions[] = 'swf';
						$allowed_extensions[] = 'SWF';
						// Quick time files
						$allowed_extensions[] = 'mov';
						$allowed_extensions[] = 'MOV';
						$allowed_extensions[] = 'mp4';
						$allowed_extensions[] = 'MP4';
						// Different files
						$allowed_extensions[] = 'mp3';
						$allowed_extensions[] = 'MP3';
						$allowed_extensions[] = 'mpeg';
						$allowed_extensions[] = 'MPEG';
						$allowed_extensions[] = 'mpg';
						$allowed_extensions[] = 'MPG';
						// Picture files
						$allowed_extensions[] = 'png';
						$allowed_extensions[] = 'PNG';
						$allowed_extensions[] = 'jpg';
						$allowed_extensions[] = 'JPG';
						$allowed_extensions[] = 'jpeg';
						$allowed_extensions[] = 'JPEG';
						$allowed_extensions[] = 'gif';
						$allowed_extensions[] = 'GIF';
						$allowed_extensions[] = 'tif';
						$allowed_extensions[] = 'TIF';
						$allowed_extensions[] = 'tiff';
						$allowed_extensions[] = 'TIFF';

						// Check if categories exists
						$sql = 'SELECT COUNT(cat_id) AS total_cats
							FROM ' . DM_EDS_CAT_TABLE;
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$total_cats = $row['total_cats'];
						$db->sql_freeresult($result);

						if ( $total_cats <= 0 )
						{
							trigger_error($user->lang['ACP_NO_CAT_UPLOAD'] . adm_back_link($this->u_action), E_USER_WARNING);
						}

						$fileupload = new fileupload();
						$fileupload->fileupload('', $allowed_extensions);

						$target_folder = request_var('parent', 0);
						$upload_name = request_var('filename', '');

						// Check if FTP upload and normal upload is entered
						if ( $ftp_upload && $upload_name )
						{
							trigger_error($user->lang['ACP_FTP_UPLOAD'] . adm_back_link($this->u_action), E_USER_WARNING);
						}

						$sql = 'SELECT cat_sub_dir
							FROM ' . DM_EDS_CAT_TABLE . '
							WHERE cat_id = ' . $target_folder;
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$target = $row['cat_sub_dir'];
						$db->sql_freeresult($result);

						$upload_dir = $dm_eds_file_path . $target;

						// Ab hier Trennung ....
						if ( !$ftp_upload )
						{
							$upload_file = $fileupload->form_upload('filename');

							if (file_exists($phpbb_root_path . $upload_dir . '/' . $upload_file->uploadname))
							{
								trigger_error($user->lang['ACP_UPLOAD_FILE_EXISTS'] . adm_back_link($this->u_action), E_USER_WARNING);//continue;
							}

							if (!$upload_file->uploadname)
							{
								trigger_error($user->lang['ACP_NO_FILENAME'] . adm_back_link($this->u_action), E_USER_WARNING);//continue;
							}

							$upload_file->move_file($upload_dir, false, false, false);
							@chmod($upload_file->destination_file, 0644);

							if (sizeof($upload_file->error) && $upload_file->uploadname)
							{
								$upload_file->remove();
								trigger_error(implode('<br />', $upload_file->error));
							}
							// End the upload
							
							$filesize = @filesize($phpbb_root_path . $upload_dir . '/' . $upload_file->uploadname);
							$sql_ary = array(
								'download_title'	=> $title,
								'download_desc'     => $desc,
								'download_filename'	=> $upload_file->uploadname,
								'download_version'	=> $dl_version,
								'download_cat_id'	=> $cat_option,
								'upload_time'		=> $upload_time,
								'cost_per_dl'		=> $costs_dl,
								'last_changed_time'	=> $last_changed_time,
								'bbcode_uid'        => $uid,
								'bbcode_bitfield'   => $bitfield,
								'bbcode_options'	=> $options,
								'filesize'			=> $filesize,
								'points_user_id'	=> $transfer_user['user_id'],
							);

							// Check, if filesize is greater than PHP ini allows
							if ( $unit == 'MB' )
							{ 
								$multiplier = 1048576;
							}
							else if ( $unit == 'KB' )
							{
								$multiplier = 1024;
							}

							if ( $filesize  > ($max_filesize * $multiplier) )
							{
								unlink($phpbb_root_path . $upload_dir . '/' . $upload_file->uploadname);
								trigger_error($user->lang['ACP_FILE_TOO_BIG'] . adm_back_link($this->u_action), E_USER_WARNING);	
							}
						}
						else
						{
							// check, if FTP upload file exists
							if ( !file_exists($phpbb_root_path . $upload_dir . '/' . $ftp_upload) )
							{
								trigger_error($user->lang['ACP_UPLOAD_FILE_NOT_EXISTS'] . adm_back_link($this->u_action), E_USER_WARNING);//continue;
							}
							
							$filesize = @filesize($phpbb_root_path . $upload_dir . '/' . $ftp_upload);
							$sql_ary = array(
								'download_title'	=> $title,
								'download_desc'     => $desc,
								'download_filename'	=> $ftp_upload,
								'download_version'	=> $dl_version,
								'download_cat_id'	=> $cat_option,
								'upload_time'		=> $upload_time,
								'cost_per_dl'		=> $costs_dl,
								'last_changed_time'	=> $last_changed_time,
								'bbcode_uid'        => $uid,
								'bbcode_bitfield'   => $bitfield,
								'bbcode_options'	=> $options,
								'filesize'			=> $filesize,
								'points_user_id'	=> $transfer_user['user_id'],
							);
						}
						// Ende der Trennung ....
						
						// Announce download, if enabled
						if ( $eds_values['announce_enable'] == 1 )
						{
							$sql = 'SELECT *
								FROM ' . DM_EDS_CAT_TABLE . '
								WHERE cat_id = ' . $cat_option;
							$result = $db->sql_query($sql);
							$row = $db->sql_fetchrow($result);
							$cat_name = $row['cat_name'];
							$db->sql_freeresult($result);
							
							if ( empty($dl_version) )
							{
								$dl_title = $title;
							}
							else
							{
								$dl_title = $title . ' v' . $dl_version;
							}
							
							$download_link = '[url=' . generate_board_url() . '/dm_eds/showcat.php?id=' . $cat_option . ']' . $user->lang['ACP_CLICK'] . '[/url]';
							$download_subject = sprintf($user->lang['ACP_ANNOUNCE_TITLE'], $dl_title);
							$download_msg = sprintf($user->lang['ACP_ANNOUNCE_MSG'], $title, generate_text_for_display($desc, $uid, $bitfield, $options), $cat_name, $download_link);
							$this->create_announcement($download_subject, $download_msg, $eds_values['announce_forum']);
						}

						$db->sql_query('INSERT INTO ' . DM_EDS_TABLE .' ' . $db->sql_build_array('INSERT', $sql_ary));
						trigger_error($user->lang['ACP_NEW_ADDED'] . adm_back_link($this->u_action));
					break;

					// Edit an existing download
					case 'edit':
						$this->page_title = 'ACP_EDIT_DOWNLOADS';
						$this->tpl_name = 'acp_dm_eds_edit';
						$form_action = $this->u_action. '&amp;action=update';
						$lang_mode = $user->lang['ACP_EDIT_DOWNLOADS'];

						$action = (!isset($_GET['action'])) ? '' : $_GET['action'];
						$action = ((isset($_POST['submit']) && !$_POST['id']) ? 'add' : $action );

						$id = request_var('id', '');

						$sql = 'SELECT d.*, c.*
							FROM ' . DM_EDS_TABLE . ' d 
								LEFT JOIN ' . DM_EDS_CAT_TABLE . ' c
								ON d.download_cat_id = c.cat_id
							WHERE download_id = ' . $id;
						$result = $db->sql_query_limit($sql,1);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);
						decode_message($row['download_desc'], $row['bbcode_uid']);
						$download_id = $row['download_id'];
						$download_version = $row['download_version'];

						$sql = 'SELECT *
							FROM ' . DM_EDS_CAT_TABLE . '
							ORDER BY LOWER(cat_name)';
						$result = $db->sql_query($sql);
						$cats = array();
						while ($row2 = $db->sql_fetchrow($result))
						{
							$cats[$row2['cat_id']] = array( 
								'cat_title'	=> $row2['cat_name'], 
								'cat_id'	=> $row2['cat_id'],
							);
						}
						$db->sql_freeresult($result);

						$cat_options = '';
						foreach($cats as $key => $value)
						{
							if ($key == $row['download_cat_id'])
							{
								$cat_options .= '<option value="' . $value['cat_id'] . '" selected="selected">' . $value['cat_title'] . '</option>';
							}
							else
							{
								$cat_options .= '<option value="' . $value['cat_id'] . '">' . $value['cat_title'] . '</option>';
							}
						}

						if ( defined('IN_ULTIMATE_POINTS') )
						{
							$sql1 = 'SELECT d.*, u.*
								FROM ' . DM_EDS_TABLE . ' d 
									LEFT JOIN ' . USERS_TABLE . ' u
									ON d.points_user_id = u.user_id
								WHERE download_id = ' . $id;
							$result1 = $db->sql_query_limit($sql1,1);
							$row1 = $db->sql_fetchrow($result1);
							$db->sql_freeresult($result1);
							$transfer_user1 = $row1['username'];
							
							$template->assign_vars(array(
								'S_UPS_EXIST'				=> true,
								'POINTS_NAME'				=> $config['points_name'],
								'POINTS_TITLE_EXPLAIN' 		=> sprintf($user->lang['ACP_COST_EXPLAIN'], $config['points_name']),
								'ACP_COST_TITLE_EXPLAIN' 	=> sprintf($user->lang['ACP_COST_TITLE_EXPLAIN'], $config['points_name']),
								'TRANSFER_USER'				=> $transfer_user1,
								'U_FIND_USERNAME'			=> append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=searchuser&amp;form=select_user&amp;field=username&amp;select_single=true'),
							));
						}

						$max_filesize = @ini_get('upload_max_filesize');
						$unit = 'MB';

						if (!empty($max_filesize))
						{
							$unit = strtolower(substr($max_filesize, -1, 1));
							$max_filesize = (int) $max_filesize;

							$unit = ($unit == 'k') ? 'KB' : (($unit == 'g') ? 'GB' : 'MB');
						}

						$template->assign_vars(array(
							'ID'				=> $download_id,
							'TITLE'				=> $row['download_title'],
							'DESC'				=> $row['download_desc'],
							'FILENAME'			=> $row['download_filename'],
							'CATNAME'			=> $row['cat_name'],
							'DL_VERSION'		=> $download_version,
							'COST_PER_DL'		=> $row['cost_per_dl'],
							'PARENT_OPTIONS'	=> $cat_options,
							'ALLOWED_SIZE'		=> sprintf($user->lang['ACP_NEW_DOWNLOAD_SIZE'], $max_filesize, $unit),
							'U_ACTION'			=> $form_action,
							'L_MODE_TITLE'		=> $lang_mode,
							
						));
					break;

					// Change an existing download
					case 'update':
						$filecheck = $filecheck_current = $new_filename = '';

						$id = request_var('id', '');

						$sql = 'SELECT d.download_cat_id, d.download_filename, d.filesize, c.cat_sub_dir
							FROM ' . DM_EDS_TABLE . ' d
							LEFT JOIN ' . DM_EDS_CAT_TABLE . ' c
								ON d.download_cat_id = c.cat_id
							WHERE download_id = ' . $id;
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$current_cat_id = $row['download_cat_id'];
						$current_cat_name = $row['cat_sub_dir'];
						$current_filename = $row['download_filename'];
						$current_filesize = $row['filesize'];
						$db->sql_freeresult($result);

						$title 		= utf8_normalize_nfc(request_var('title', '', true));
						$v_cat_id	= request_var('parent', '');
						$dl_version	= request_var('dl_version', '', true);
						$costs_dl	= request_var('cost_per_dl', 0.00);
						$last_changed_time = time();
						$desc 		= utf8_normalize_nfc(request_var('desc', '', true));
						$announce_up = request_var('announce_up', '');
						$ftp_upload	= request_var('ftp_upload', '', true);

						$uid = $bitfield = $options = ''; // will be modified by generate_text_for_storage
						$allow_bbcode = $allow_urls = $allow_smilies = true;
						generate_text_for_storage($desc, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);

						$username1 	= request_var('username', '', true);
						$username 	= strtolower($username1);
						$ftp_upload	= request_var('ftp_upload', '', true);

						// Select the user data to transfer to
						$sql_array = array(
							'SELECT'    => '*',
							'FROM'      => array(
								USERS_TABLE => 'u',
							),
							'WHERE'		=> 'username_clean = "' . $db->sql_escape(utf8_clean_string($username)) . '"',
						);
						$sql = $db->sql_build_query('SELECT', $sql_array);
						$result = $db->sql_query($sql);
						$transfer_user = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);
						
						if ( !$transfer_user )
						{
							$transfer_user['user_id'] = 0;
						}

						// Here you can add additional extenstions
						// Always use lower and upper case extensions
						$allowed_extensions = array();
						// Archive extenstions
						$allowed_extensions[] = 'zip';
						$allowed_extensions[] = 'ZIP';
						$allowed_extensions[] = 'rar';
						$allowed_extensions[] = 'RAR';
						$allowed_extensions[] = '7z';
						$allowed_extensions[] = '7Z';
						$allowed_extensions[] = 'ace';
						$allowed_extensions[] = 'ACE';
						$allowed_extensions[] = 'gtar';
						$allowed_extensions[] = 'GTAR';
						$allowed_extensions[] = 'gz';
						$allowed_extensions[] = 'GZ';
						$allowed_extensions[] = 'tar';
						$allowed_extensions[] = 'TAR';
						// Text files
						$allowed_extensions[] = 'txt';
						$allowed_extensions[] = 'TXT';
						// Documents
						$allowed_extensions[] = 'doc';
						$allowed_extensions[] = 'DOC';
						$allowed_extensions[] = 'docx';
						$allowed_extensions[] = 'DOCX';
						$allowed_extensions[] = 'xls';
						$allowed_extensions[] = 'XLS';
						$allowed_extensions[] = 'xlsx';
						$allowed_extensions[] = 'XLSX';
						$allowed_extensions[] = 'ppt';
						$allowed_extensions[] = 'PPT';
						$allowed_extensions[] = 'pptx';
						$allowed_extensions[] = 'PPTX';
						$allowed_extensions[] = 'pdf';
						$allowed_extensions[] = 'PDF';
						// Real Media files
						$allowed_extensions[] = 'ram';
						$allowed_extensions[] = 'RAM';
						$allowed_extensions[] = 'rm';
						$allowed_extensions[] = 'RM';
						// Windows Media files
						$allowed_extensions[] = 'wma';
						$allowed_extensions[] = 'WMA';
						$allowed_extensions[] = 'wmv';
						$allowed_extensions[] = 'WMV';
						// Flash files
						$allowed_extensions[] = 'swf';
						$allowed_extensions[] = 'SWF';
						// Quick time files
						$allowed_extensions[] = 'mov';
						$allowed_extensions[] = 'MOV';
						$allowed_extensions[] = 'mp4';
						$allowed_extensions[] = 'MP4';
						// Different files
						$allowed_extensions[] = 'mp3';
						$allowed_extensions[] = 'MP3';
						$allowed_extensions[] = 'mpeg';
						$allowed_extensions[] = 'MPEG';
						$allowed_extensions[] = 'mpg';
						$allowed_extensions[] = 'MPG';
						// Picture files
						$allowed_extensions[] = 'png';
						$allowed_extensions[] = 'PNG';
						$allowed_extensions[] = 'jpg';
						$allowed_extensions[] = 'JPG';
						$allowed_extensions[] = 'jpeg';
						$allowed_extensions[] = 'JPEG';
						$allowed_extensions[] = 'gif';
						$allowed_extensions[] = 'GIF';
						$allowed_extensions[] = 'tif';
						$allowed_extensions[] = 'TIF';
						$allowed_extensions[] = 'tiff';
						$allowed_extensions[] = 'TIFF';

						$fileupload = new fileupload();
						$fileupload->fileupload('', $allowed_extensions);

						$target_folder = request_var('parent', 0);
						$upload_name = request_var('filename', '');

						// Check if FTP upload and normal upload is entered
						if ( $ftp_upload && $upload_name )
						{
							trigger_error($user->lang['ACP_FTP_UPLOAD'] . adm_back_link($this->u_action), E_USER_WARNING);
						}

						$sql = 'SELECT cat_sub_dir
							FROM ' . DM_EDS_CAT_TABLE . '
							WHERE cat_id = ' . $target_folder;
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$target = $row['cat_sub_dir'];
						$db->sql_freeresult($result);

						$upload_dir = $dm_eds_file_path . $target;

						// Ab hier Trennung ....
						if ( !$ftp_upload )
						{
							$upload_file = $fileupload->form_upload('filename');

							$new_filename = $upload_file->uploadname;

							if (!$upload_file->uploadname)
							{
								$new_filename = $current_filename;
								$filesize = $current_filesize;
							}
							else
							{
								$delete_file = $phpbb_root_path . $dm_eds_file_path . $current_cat_name .'/' . $current_filename;
								unlink($delete_file);

								$upload_file->move_file($upload_dir, false, false, false);
								@chmod($upload_file->destination_file, 0644);

								if (sizeof($upload_file->error) && $upload_file->uploadname)
								{
									$upload_file->remove();
									trigger_error(implode('<br />', $upload_file->error));
								}
								
								$filesize = @filesize($phpbb_root_path . $upload_dir . '/' . $new_filename);
							}							
                        
							$sql_ary = array(
								'download_title'	=> $title,
								'download_version'	=> $dl_version,
								'download_desc'    	=> $desc,
								'download_filename'	=> $new_filename,
								'download_cat_id'	=> $v_cat_id,
								'cost_per_dl'		=> $costs_dl,
								'last_changed_time' => $last_changed_time,
								'bbcode_uid'        => $uid,
								'bbcode_bitfield'   => $bitfield,
								'bbcode_options'    => $options,
								'filesize'			=> $filesize,
								'points_user_id'	=> $transfer_user['user_id'],
							);

							// If the title is empty, return an error
							if ( $title == '' )
							{
								trigger_error($user->lang['ACP_NEED_DATA'] . adm_back_link($this->u_action), E_USER_WARNING);	
							}
							else
							{
								// Check, if the file already is in the directory
								$sql = 'SELECT cat_sub_dir
									FROM ' . DM_EDS_CAT_TABLE . '
									WHERE cat_id = ' . $v_cat_id;
								$result = $db->sql_query($sql);
								$row = $db->sql_fetchrow($result);
								$cat_dir = $row['cat_sub_dir'];
								$db->sql_freeresult($result);

								$filecheck = $phpbb_root_path . $dm_eds_file_path . $cat_dir .'/' . $new_filename;
								$filecheck_current = $phpbb_root_path . $dm_eds_file_path . $current_cat_name .'/' . $new_filename;

								// If file should move to new category
								if ( $current_cat_id != $v_cat_id )
								{
									// Check, if the file already exists in the cat, where to move
									if ( file_exists($filecheck) )
									{
										trigger_error($user->lang['ACP_UPLOAD_FILE_EXISTS'] . adm_back_link($this->u_action), E_USER_WARNING);//continue;
									}
									else
									{
										// Announce download, if enabled
										if ( $eds_values['announce_enable'] == 1 && $announce_up != '' )
										{
											$sql = 'SELECT *
												FROM ' . DM_EDS_CAT_TABLE . '
												WHERE cat_id = ' . $v_cat_id;
											$result = $db->sql_query($sql);
											$row = $db->sql_fetchrow($result);
											$cat_name = $row['cat_name'];
											$db->sql_freeresult($result);
											
											if ( empty($dl_version) )
											{
												$dl_title = $title;
											}
											else
											{
												$dl_title = $title . ' v' . $dl_version;
											}
											
											$download_link = '[url=' . generate_board_url() . '/dm_eds/showcat.php?id=' . $v_cat_id . ']' . $user->lang['ACP_CLICK'] . '[/url]';
											$download_subject = sprintf($user->lang['ACP_ANNOUNCE_UP_TITLE'], $dl_title);
											$download_msg = sprintf($user->lang['ACP_ANNOUNCE_UP_MSG'], $title, generate_text_for_display($desc, $uid, $bitfield, $options), $cat_name, $download_link);

											$this->create_announcement($download_subject, $download_msg, $eds_values['announce_forum']);
										}
										
										if ( rename(($phpbb_root_path . $dm_eds_file_path . $current_cat_name . '/' .$new_filename), ($phpbb_root_path . $dm_eds_file_path . $cat_dir . '/' . $new_filename)))
										{
											$db->sql_query('UPDATE ' . DM_EDS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . ' WHERE download_id = ' . $id);
											$cache->destroy('sql', DM_EDS_TABLE);
										}
										trigger_error($user->lang['ACP_DOWNLOAD_UPDATED'] . adm_back_link($this->u_action));
										return;
									}
								}
								else // If only data changes and no new cat
								{
									// Announce download, if enabled
									if ( $eds_values['announce_enable'] == 1 && $announce_up != '' )
									{
										$sql = 'SELECT *
											FROM ' . DM_EDS_CAT_TABLE . '
											WHERE cat_id = ' . $v_cat_id;
										$result = $db->sql_query($sql);
										$row = $db->sql_fetchrow($result);
										$cat_name = $row['cat_name'];
										$db->sql_freeresult($result);
										
										if ( empty($dl_version) )
										{
											$dl_title = $title;
										}
										else
										{
											$dl_title = $title . ' v' . $dl_version;
										}
										
										$download_link = '[url=' . generate_board_url() . '/dm_eds/showcat.php?id=' . $v_cat_id . ']' . $user->lang['ACP_CLICK'] . '[/url]';
										$download_subject = sprintf($user->lang['ACP_ANNOUNCE_UP_TITLE'], $dl_title);
										$download_msg = sprintf($user->lang['ACP_ANNOUNCE_UP_MSG'], $title, generate_text_for_display($desc, $uid, $bitfield, $options), $cat_name, $download_link);

										$this->create_announcement($download_subject, $download_msg, $eds_values['announce_forum']);
									}
									$db->sql_query('UPDATE ' . DM_EDS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . ' WHERE download_id = ' . $id);
									$cache->destroy('sql', DM_EDS_TABLE);
									trigger_error($user->lang['ACP_DOWNLOAD_UPDATED'] . adm_back_link($this->u_action));
									return;
								}
							}
						}
						else
						{
							// check, if FTP upload file exists
							if ( !file_exists($phpbb_root_path . $upload_dir . '/' . $ftp_upload) )
							{
								trigger_error($user->lang['ACP_UPLOAD_FILE_NOT_EXISTS'] . adm_back_link($this->u_action), E_USER_WARNING);//continue;
							}
							
							$filesize = @filesize($phpbb_root_path . $upload_dir . '/' . $ftp_upload);
							$sql_ary = array(
								'download_title'	=> $title,
								'download_desc'     => $desc,
								'download_filename'	=> $ftp_upload,
								'download_version'	=> $dl_version,
								'download_cat_id'	=> $cat_option,
								'upload_time'		=> $upload_time,
								'cost_per_dl'		=> $costs_dl,
								'last_changed_time'	=> $last_changed_time,
								'bbcode_uid'        => $uid,
								'bbcode_bitfield'   => $bitfield,
								'bbcode_options'	=> $options,
								'filesize'			=> $filesize,
								'points_user_id'	=> $transfer_user['user_id'],
							);
						}
						// Ende der Trennung ....
					break;

					// Delete an existing download
					case 'delete':
						if (confirm_box(true))
						{
							$sql = 'SELECT c.cat_sub_dir, d.download_filename
								FROM ' . DM_EDS_CAT_TABLE . ' c
								LEFT JOIN ' . DM_EDS_TABLE . ' d
									ON c.cat_id = d.download_cat_id
								WHERE d.download_id = ' . $id;
							$result = $db->sql_query($sql);
							$row = $db->sql_fetchrow($result);
							$cat_dir = $row['cat_sub_dir'];
							$file_name = $row['download_filename'];
							$db->sql_freeresult($result);

							$delete_file = $phpbb_root_path . $dm_eds_file_path . $cat_dir .'/' . $file_name;
							unlink($delete_file);

							$sql = 'DELETE FROM ' . DM_EDS_TABLE . '
								WHERE download_id = '. $id;
							$db->sql_query($sql);
							trigger_error($user->lang['ACP_DOWNLOAD_DELETED'] . adm_back_link($this->u_action));
						}
						else
						{
							confirm_box(false, $user->lang['ACP_REALLY_DELETE'], build_hidden_fields(array(
								'download_id'	=> $id,
								'action'	=> 'delete',
								))
							);
						}
					break;
				}
			break;

			case 'userguide':
            	$this->page_title = 'ACP_USERGUIDE';
				$this->tpl_name = 'acp_dm_eds_userguide';

				$template->assign_vars(array(
					'S_IN_EDS_USERGUIDE'		=> true,
					'L_BACK_TO_TOP'				=> $user->lang['BACK_TO_TOP'],
					'ICON_BACK_TO_TOP'			=> '<img src="' . $phpbb_admin_path . 'images/icon_up.gif" style="vertical-align: middle;" alt="' . $user->lang['BACK_TO_TOP'] . '" title="' . $user->lang['BACK_TO_TOP'] . '" />',
				));

				$user->add_lang('mods/dm_eds', false, true);

				// Pull the array data from the lang pack
				foreach ($user->help as $help_ary)
				{
					if ($help_ary[0] == '--')
					{
						$template->assign_block_vars('userguide_block', array(
							'BLOCK_TITLE'		=> $help_ary[1])
						);

						continue;
					}

					$template->assign_block_vars('userguide_block.userguide_row', array(
						'USERGUIDE_QUESTION'		=> $help_ary[0],
						'USERGUIDE_ANSWER'			=> $help_ary[1])
					);
				}
			break;
		}
	}

	/**
	* Define all the functions, which are used above
	*/

	/**
	* Function for managing categories
	*/
	function manage_cats()
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_admin_path, $phpbb_root_path, $dm_eds_file_path, $phpEx;
		$catrow = array();
		$parent_id = request_var('parent_id', 0);
		$template->assign_vars(array(
			'S_MODE_MANAGE'	=> true,
			'S_ACTION'		=> $this->u_action . '&amp;action=create&amp;parent_id=' . $parent_id,
		));
		if (!$parent_id)
		{
			$navigation = $user->lang['ACP_CAT_INDEX'];
		}
		else
		{
			$navigation = '<a href="' . $this->u_action . '">' . $user->lang['ACP_CAT_INDEX'] . '</a>';

			$dm_eds_nav = get_cat_branch($parent_id, 'parents', 'descending');
			foreach ($dm_eds_nav as $row)
			{
				if ($row['cat_id'] == $parent_id)
				{
					$navigation .= ' -&gt; ' . $row['cat_name'];
				}
				else
				{
					$navigation .= ' -&gt; <a href="' . $this->u_action . '&amp;parent_id=' . $row['cat_id'] . '">' . $row['cat_name'] . '</a>';
				}
			}
		}
		$dm_eds = array();
		$sql = 'SELECT *
			FROM ' . DM_EDS_CAT_TABLE . '
			WHERE parent_id = ' . $parent_id . '
			ORDER BY left_id ASC';
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$dm_eds[] = $row;
		}

		for( $i = 0; $i < count($dm_eds); $i++ )
		{
			$folder_image = ($dm_eds[$i]['left_id'] + 1 != $dm_eds[$i]['right_id']) ? '<img src="images/icon_subfolder.gif" alt="' . $user->lang['SUBFORUM'] . '" />' : '<img src="images/icon_folder.gif" alt="' . $user->lang['FOLDER'] . '" />';
			
			$template->assign_block_vars('catrow', array(
				'FOLDER_IMAGE'			=> $folder_image,
				'U_CAT'					=> $this->u_action . '&amp;parent_id=' . $dm_eds[$i]['cat_id'],
				'CAT_NAME'				=> $dm_eds[$i]['cat_name'],
				'CAT_DESCRIPTION'		=> generate_text_for_display($dm_eds[$i]['cat_desc'], $dm_eds[$i]['cat_desc_uid'], $dm_eds[$i]['cat_desc_bitfield'], $dm_eds[$i]['cat_desc_options']),
				'U_MOVE_UP'				=> $this->u_action . '&amp;action=move&amp;move=move_up&amp;cat_id=' . $dm_eds[$i]['cat_id'],
				'U_MOVE_DOWN'			=> $this->u_action . '&amp;action=move&amp;move=move_down&amp;cat_id=' . $dm_eds[$i]['cat_id'],
				'U_EDIT'				=> $this->u_action . '&amp;action=edit&amp;cat_id=' . $dm_eds[$i]['cat_id'],
				'U_DELETE'				=> $this->u_action . '&amp;action=delete&amp;cat_id=' . $dm_eds[$i]['cat_id'],
			));
		}
		$template->assign_vars(array(
			'NAVIGATION'		=> $navigation,
			'S_DM_EDS'			=> $parent_id,
			'U_EDIT'			=> ($parent_id) ? $this->u_action . '&amp;action=edit&amp;cat_id=' . $parent_id : '',
			'U_DELETE'			=> ($parent_id) ? $this->u_action . '&amp;action=delete&amp;cat_id=' . $parent_id : '',
		));
	}

	/**
	* Function for create a category
	*/
	function create_cat()
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_admin_path, $phpbb_root_path, $dm_eds_file_path, $phpEx;

		include_once($phpbb_root_path . 'includes/message_parser.' . $phpEx);
		$submit = (isset($_POST['submit'])) ? true : false;
		if($submit)
		{
			$dm_eds_data = array();
			$dm_eds_data = array(
				'cat_name'			=> request_var('cat_name', '', true),
				'cat_sub_dir'		=> request_var('cat_sub_dir', ''),
				'parent_id'			=> request_var('parent_id', 0),
				'cat_parents'		=> request_var('cat_parents', 0),
				'cat_desc'			=> utf8_normalize_nfc(request_var('cat_desc', '', true)),
				'cat_desc_options'	=> 7,
			);

			generate_text_for_storage($dm_eds_data['cat_desc'], $dm_eds_data['cat_desc_uid'], $dm_eds_data['cat_desc_bitfield'], $dm_eds_data['cat_desc_options'], request_var('desc_parse_bbcode', false), request_var('desc_parse_urls', false), request_var('desc_parse_smilies', false));

			// Create variable for the cat_sub_dir name
			$cat_sub_dir_name = '';
			$cat_sub_dir_name = $dm_eds_data['cat_sub_dir'];

			// Check, if sub-dir is filled
			if ( empty($cat_sub_dir_name) )
			{
				trigger_error($user->lang['ACP_CAT_NAME_ERROR'] . adm_back_link($this->u_action), E_USER_WARNING);
			}

			// Do the check, if cat_sub_dir has valid characters only

			// Let's make an array of allowed characters
			$allowed = range('a', 'z'); //latin letters
			$allowed = array_merge($allowed, range(0, 9)); //numbers
			// Additional symbols (recommended only these two below)
			$allowed[] = '_';
			$allowed[] = '-';
			$allowed = implode($allowed);

			// Now split the new category name into single parts
			$new_dir_name = str_split($cat_sub_dir_name); //works only in PHP5!

			// Check each character if it's allowed
			foreach ( $new_dir_name as $var )
			{
				if ( stristr($allowed, $var) === false)
				{
					trigger_error($user->lang['ACP_WRONG_CHAR'] . adm_back_link($this->u_action), E_USER_WARNING);
				}
			}

			// Check if sub dir name already exists
			$sql = 'SELECT * FROM ' . DM_EDS_CAT_TABLE . "
			WHERE cat_sub_dir LIKE '$cat_sub_dir_name'";
			$result= $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			if ( $row )
			{
				trigger_error($user->lang['ACP_CAT_EXIST'] . adm_back_link($this->u_action), E_USER_WARNING);
			}

			if ($dm_eds_data['parent_id'])
			{
				$sql = 'SELECT left_id, right_id
					FROM ' . DM_EDS_CAT_TABLE . '
					WHERE cat_id = ' . $dm_eds_data['parent_id'];
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				if (!$row)
				{
					trigger_error($user->lang['PARENT_NOT_EXIST'] . adm_back_link($this->u_action . '&amp;' . $this->parent_id), E_USER_WARNING);
				}

				$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . '
					SET left_id = left_id + 2, right_id = right_id + 2
					WHERE left_id > ' . $row['right_id'];
				$db->sql_query($sql);

				$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . '
					SET right_id = right_id + 2
					WHERE ' . $row['left_id'] . ' BETWEEN left_id AND right_id';
				$db->sql_query($sql);

				$dm_eds_data['left_id'] = $row['right_id'];
				$dm_eds_data['right_id'] = $row['right_id'] + 1;
			}
			else
			{
				$sql = 'SELECT MAX(right_id) AS right_id
					FROM ' . DM_EDS_CAT_TABLE;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				$dm_eds_data['left_id'] = $row['right_id'] + 1;
				$dm_eds_data['right_id'] = $row['right_id'] + 2;
			}
			$db->sql_query('INSERT INTO ' . DM_EDS_CAT_TABLE . ' ' . $db->sql_build_array('INSERT', $dm_eds_data));
			$cache->destroy('sql', DM_EDS_CAT_TABLE);

			// Check if created foldername already exists
			if ( is_dir($phpbb_root_path . $dm_eds_file_path . $cat_sub_dir_name) )
			{
				trigger_error($user->lang['ACP_CAT_NEW_DONE'] . adm_back_link($this->u_action . '&amp;parent_id=' . $dm_eds_data['parent_id']));
			}
			else if ( mkdir(($phpbb_root_path . $dm_eds_file_path . $cat_sub_dir_name)) )
			{
				if( copy(($phpbb_root_path . $dm_eds_file_path .'index.htm'), ($phpbb_root_path . $dm_eds_file_path . $cat_sub_dir_name . '/index.htm')) )
				{
				trigger_error($user->lang['ACP_CAT_NEW_DONE'] . adm_back_link($this->u_action . '&amp;parent_id=' . $dm_eds_data['parent_id']));
				}
			}
		}
		$parent_options = make_cat_select(request_var('parent_id', 0), false, false, false, false);
		$template->assign_vars(array(
			'S_MODE_CREATE'				=> true,

			'S_ACTION'					=> $this->u_action . '&amp;parent_id=' . request_var('parent_id', 0),
			'S_DESC_BBCODE_CHECKED'		=> true,
			'S_DESC_SMILIES_CHECKED'	=> true,
			'S_DESC_URLS_CHECKED'		=> true,
			'S_PARENT_OPTIONS'			=> $parent_options,
		));
	}

	/**
	* Function for editing a category
	*/
	function edit_cat()
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_admin_path, $phpbb_root_path, $dm_eds_file_path, $phpEx;
		include_once($phpbb_root_path . 'includes/message_parser.' . $phpEx);

		if (!$cat_id = request_var('cat_id', 0))
		{
			trigger_error('No Cat ID', E_USER_WARNING);
		}

		$submit = (isset($_POST['submit'])) ? true : false;
		if($submit)
		{
			$dm_eds_data = array();
			$dm_eds_data = array(
				'cat_name'						=> request_var('cat_name', '', true),
				'parent_id'						=> request_var('parent_id', 0),
				'cat_parents'					=> '',
				'cat_desc_options'				=> 7,
				'cat_desc'						=> utf8_normalize_nfc(request_var('cat_desc', '', true)),
			);
			generate_text_for_storage($dm_eds_data['cat_desc'], $dm_eds_data['cat_desc_uid'], $dm_eds_data['cat_desc_bitfield'], $dm_eds_data['cat_desc_options'], request_var('desc_parse_bbcode', false), request_var('desc_parse_urls', false), request_var('desc_parse_smilies', false));
			$row = get_cat_info($cat_id);

			if ($row['parent_id'] != $dm_eds_data['parent_id'])
			{
				//how many do we have to move and how far
				$moving_ids = ($row['right_id'] - $row['left_id']) + 1;
				$sql = 'SELECT MAX(right_id) AS right_id
					FROM ' . DM_EDS_CAT_TABLE;
				$result = $db->sql_query($sql);
				$highest = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
				$moving_distance = ($highest['right_id'] - $row['left_id']) + 1;
				$stop_updating = $moving_distance + $row['left_id'];

				//update the moving download... move it to the end
				$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . '
					SET right_id = right_id + ' . $moving_distance . ',
						left_id = left_id + ' . $moving_distance . '
					WHERE left_id >= ' . $row['left_id'] . '
						AND right_id <= ' . $row['right_id'];
				$db->sql_query($sql);
				$new['left_id'] = $row['left_id'] + $moving_distance;
				$new['right_id'] = $row['right_id'] + $moving_distance;

				//close the gap, we got
				if ($dm_eds_data['parent_id'] == 0)
				{//we move to root
					//left_id
					$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . '
						SET left_id = left_id - ' . $moving_ids . '
						WHERE left_id >= ' . $row['left_id'];
					$db->sql_query($sql);
					//right_id
					$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . '
						SET right_id = right_id - ' . $moving_ids . '
						WHERE right_id >= ' . $row['left_id'];
					$db->sql_query($sql);
				}
				else
				{
					//close the gap
					//left_id
					$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . '
						SET left_id = left_id - ' . $moving_ids . '
						WHERE left_id >= ' . $row['left_id'] . '
							AND right_id <= ' . $stop_updating;
					$db->sql_query($sql);
					//right_id
					$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . '
						SET right_id = right_id - ' . $moving_ids . '
						WHERE right_id >= ' . $row['left_id'] . '
							AND right_id <= ' . $stop_updating;
					$db->sql_query($sql);

					//create new gap
					//need parent_information
					$parent = get_cat_info($dm_eds_data['parent_id']);
					//left_id
					$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . '
						SET left_id = left_id + ' . $moving_ids . '
						WHERE left_id >= ' . $parent['right_id'] . '
							AND right_id <= ' . $stop_updating;
					$db->sql_query($sql);
					//right_id
					$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . '
						SET right_id = right_id + ' . $moving_ids . '
						WHERE right_id >= ' . $parent['right_id'] . '
							AND right_id <= ' . $stop_updating;
					$db->sql_query($sql);

					//close the gap again
					//new parent right_id!!!
					$parent['right_id'] = $parent['right_id'] + $moving_ids;
					$move_back = ($new['right_id'] - $parent['right_id']) + 1;
					$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . '
						SET left_id = left_id - ' . $move_back . ',
							right_id = right_id - ' . $move_back . '
						WHERE left_id >= ' . $stop_updating;
					$db->sql_query($sql);
				}
			}

			if ($row['cat_name'] != $dm_eds_data['cat_name'])
			{
				// the forum name has changed, clear the parents list of all forums (for safety)
				$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . "
					SET cat_parents = ''";
				$db->sql_query($sql);
			}

			$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . ' 
					SET ' . $db->sql_build_array('UPDATE', $dm_eds_data) . '
					WHERE cat_id  = ' . (int) $cat_id;
			$db->sql_query($sql);
			$cache->destroy('sql', DM_EDS_CAT_TABLE);

			trigger_error($user->lang['ACP_CAT_EDIT_DONE'] . adm_back_link($this->u_action . '&amp;parent_id=' . $dm_eds_data['parent_id']));
		}

		$sql = 'SELECT *
			FROM ' . DM_EDS_CAT_TABLE . "
			WHERE cat_id = '$cat_id'";
		$result = $db->sql_query($sql);

		if ($db->sql_affectedrows($result) == 0)
		{
			trigger_error($user->lang['ACP_CAT_NOT_EXIST'], E_USER_WARNING);
		}
		$dm_eds_data = $db->sql_fetchrow($result);
		$dm_eds_desc_data = generate_text_for_edit($dm_eds_data['cat_desc'], $dm_eds_data['cat_desc_uid'], $dm_eds_data['cat_desc_options']);
		$parents_list = make_cat_select($dm_eds_data['parent_id'], $cat_id);

		$template->assign_vars(array(
			'S_MODE_EDIT'				=> true,

			'S_ACTION'					=> $this->u_action . '&amp;action=edit&amp;cat_id=' . $cat_id,
			'S_PARENT_OPTIONS'			=> $parents_list,

			'CAT_NAME'					=> $dm_eds_data['cat_name'],
			'CAT_DESC'					=> $dm_eds_desc_data['text'],
			'CAT_SUB_DIR'				=> $dm_eds_data['cat_sub_dir'],
			'S_DESC_BBCODE_CHECKED'		=> ($dm_eds_desc_data['allow_bbcode']) ? true : false,
			'S_DESC_SMILIES_CHECKED'	=> ($dm_eds_desc_data['allow_smilies']) ? true : false,
			'S_DESC_URLS_CHECKED'		=> ($dm_eds_desc_data['allow_urls']) ? true : false,

			'S_MODE'				=> 'edit',
		));
	}

	/**
	* Function for deleting a category
	*/
	function delete_cat()
	{
		global $db, $template, $user, $cache;

		if (!$cat_id = request_var('cat_id', 0))
		{
			trigger_error('No Cat ID', E_USER_WARNING);
		}
		else
		{
			$sql = 'SELECT *
				FROM ' . DM_EDS_CAT_TABLE . "
				WHERE cat_id = '$cat_id'";
			$result = $db->sql_query($sql);
			if ($db->sql_affectedrows($result) == 0)
			{
				trigger_error($user->lang['ACP_CAT_NOT_EXIST'], E_USER_WARNING);
			}
		}

		$submit = (isset($_POST['submit'])) ? true : false;
		if($submit)
		{
			$dm_eds = get_cat_info($cat_id);
			$handle_subs = request_var('handle_subs', 0);
			$handle_downloads = request_var('handle_downloads', 0);
			if (($dm_eds['right_id'] - $dm_eds['left_id']) > 2)
			{//handle subs if there
				//we have to learn how to delete or move the subs
				if ($handle_subs >= 0)
				{
					trigger_error($user->lang['ACP_DELETE_SUB_CATS'] . adm_back_link($this->u_action), E_USER_WARNING);
				}
			}

			// Get cat directory name
			$sql = 'SELECT cat_sub_dir
				FROM ' . DM_EDS_CAT_TABLE . '
				WHERE cat_id = ' . $cat_id;
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$sub_cat_dir = $row['cat_sub_dir'];
			$db->sql_freeresult($result);

			// Check if category has files
			$sql = ' SELECT COUNT(download_id) AS has_downloads
				FROM ' . DM_EDS_TABLE . '
				WHERE download_cat_id = ' . $cat_id;
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$has_downloads = $row['has_downloads'];
			$db->sql_freeresult($result);

			if ( $has_downloads > 0 )
			{
				trigger_error($user->lang['ACP_DELETE_HAS_FILES'] . adm_back_link($this->u_action), E_USER_WARNING);
			}

			//reorder the other downloads
			//left_id
			$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . '
				SET left_id = left_id - 2
				WHERE left_id > ' . $dm_eds['left_id'];
			$db->sql_query($sql);
			//right_id
			$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . '
				SET right_id = right_id - 2
				WHERE right_id > ' . $dm_eds['left_id'];
			$db->sql_query($sql);
			$sql = 'DELETE FROM ' . DM_EDS_CAT_TABLE . "
				WHERE cat_id = '$cat_id'";
			$result = $db->sql_query($sql);
			$cache->destroy('sql', DM_EDS_CAT_TABLE);

			// Remove the folder and all of its content
			$this->remove_dir($sub_cat_dir);

			trigger_error($user->lang['ACP_CAT_DELETE_DONE'] . adm_back_link($this->u_action));
		}

		$catname = '';
		$sql = 'SELECT ec.*, COUNT(ed.download_id) AS downloads
			FROM ' . DM_EDS_CAT_TABLE . ' AS ec
			LEFT JOIN ' . DM_EDS_TABLE . ' AS ed
				ON ec.cat_id = ed.download_cat_id
			WHERE ec.cat_id = ' . $cat_id . '
			GROUP BY ec.cat_id';
		$result = $db->sql_query($sql);

		$subs_found = false;
		while($row = $db->sql_fetchrow($result))
		{
			if($row['cat_id'] == $cat_id)
			{
				$thiseds = $row;
				$subs_found = true;
			}
			else
			{
				$edsrow[] = $row;
			}

			$catname = $row['cat_name'];
		}

		if(!$subs_found)
		{
			trigger_error($user->lang['ACP_CAT_NOT_EXIST'], E_USER_WARNING);
		}
		$db->sql_freeresult($result);

		$template->assign_vars(array(
			'S_MODE_DELETE'		=> true,

			'S_CAT_ACTION'				=> $this->u_action . '&amp;action=delete&amp;dm_eds_id=' . $cat_id,
			'CAT_DELETE'				=> sprintf($user->lang['ACP_DEL_CAT'], $catname),
			'S_PARENT_OPTIONS'			=> make_cat_select($thiseds['parent_id'], $cat_id),
			'S_HAS_CHILDREN'			=> ($thiseds['left_id'] + 1 != $thiseds['right_id']) ? true : false,
			'S_HAS_DOWNLOADS'			=> ($thiseds['downloads'] > 0) ? true : false,
			'CAT_NAME'					=> $catname,
			'CAT_DESC'					=> generate_text_for_display($thiseds['cat_desc'], $thiseds['cat_desc_uid'], $thiseds['cat_desc_bitfield'], $thiseds['cat_desc_options']),
			'S_MOVE_DM_EDS_OPTIONS'		=> make_cat_select(false, $cat_id),
			'S_MOVE_IMAGE_OPTIONS'		=> make_cat_select(false, $cat_id, true),
		));
	}

	/**
	* Function for moving a category to another position
	*/
	function move_cat()
	{
		global $db, $user, $cache;

		if (!$cat_id = request_var('cat_id', 0))
		{
			trigger_error('No Cat ID', E_USER_WARNING);
		}
		else
		{
			$sql = 'SELECT *
				FROM ' . DM_EDS_CAT_TABLE . "
				WHERE cat_id = '$cat_id'";
			$result = $db->sql_query($sql);
			if ($db->sql_affectedrows($result) == 0)
			{
				trigger_error($user->lang['ACP_CAT_NOT_EXIST'], E_USER_WARNING);
			}
		}
		$move = request_var('move', '', true);
		$moving = get_cat_info($cat_id);

		$sql = 'SELECT cat_id, left_id, right_id
			FROM ' . DM_EDS_CAT_TABLE . "
			WHERE parent_id = {$moving['parent_id']}
				AND " . (($move == 'move_up') ? "right_id < {$moving['right_id']} ORDER BY right_id DESC" : "left_id > {$moving['left_id']} ORDER BY left_id ASC");
		$result = $db->sql_query_limit($sql, 1);

		$target = array();
		while ($row = $db->sql_fetchrow($result))
		{
			$target = $row;
		}
		$db->sql_freeresult($result);

		if (!sizeof($target))
		{
			// The forum is already on top or bottom
			return false;
		}

		if ($move == 'move_up')
		{
			$left_id = $target['left_id'];
			$right_id = $moving['right_id'];

			$diff_up = $moving['left_id'] - $target['left_id'];
			$diff_down = $moving['right_id'] + 1 - $moving['left_id'];

			$move_up_left = $moving['left_id'];
			$move_up_right = $moving['right_id'];
		}
		else
		{
			$left_id = $moving['left_id'];
			$right_id = $target['right_id'];

			$diff_up = $moving['right_id'] + 1 - $moving['left_id'];
			$diff_down = $target['right_id'] - $moving['right_id'];

			$move_up_left = $moving['right_id'] + 1;
			$move_up_right = $target['right_id'];
		}

		// Now do the dirty job
		$sql = 'UPDATE ' . DM_EDS_CAT_TABLE . "
			SET left_id = left_id + CASE
				WHEN left_id BETWEEN {$move_up_left} AND {$move_up_right} THEN -{$diff_up}
				ELSE {$diff_down}
			END,
			right_id = right_id + CASE
				WHEN right_id BETWEEN {$move_up_left} AND {$move_up_right} THEN -{$diff_up}
				ELSE {$diff_down}
			END,
			cat_parents = ''
			WHERE
				left_id BETWEEN {$left_id} AND {$right_id}
				AND right_id BETWEEN {$left_id} AND {$right_id}";
		$db->sql_query($sql);
		$cache->destroy('sql', DM_EDS_CAT_TABLE);
		redirect($this->u_action . '&amp;parent_id=' . $moving['parent_id']);
	}
	
	/**
	* Function for pagination
	*/
	function generate_page($replies, $url, $top)
	{
		global $config, $user;

		// Make sure $per_page is a valid value
		$per_page = ($top <= 0) ? 1 : $top;

		if (($replies) > $per_page)
		{
			$total_pages = ceil(($replies + 1) / $per_page);
			$pagination = '';

			$times = 1;
			for ($j = 0; $j < $replies + 1; $j += $per_page)
			{
				$pagination .= '<a href="' . $url . '&amp;start=' . $j . '">' . $times . '</a>';
				if ($times == 1 && $total_pages > 5)
				{
					$pagination .= ' ... ';

					// Display the last three pages
					$times = $total_pages - 3;
					$j += ($total_pages - 4) * $per_page;
				}
				else if ($times < $total_pages)
				{
					$pagination .= '<span class="page-sep">' . $user->lang['COMMA_SEPARATOR'] . '</span>';
				}
				$times++;
			}
		}
		else
		{
			$pagination = '1';
		}
		return $pagination;
	}

	/**
	* Function for removing a category and all its content
	*/
    function remove_dir($selected_dir)
	{
		global $db, $user, $cache;
		global $phpbb_root_path, $dm_eds_file_path;
		
		$current_dir = $phpbb_root_path . $dm_eds_file_path . $selected_dir;
		$empty_dir = $phpbb_root_path . $dm_eds_file_path . $selected_dir . '/';

		if($dir = @opendir($current_dir))
		{
			while (($f = readdir($dir)) !== false)
			{
				if($f > '0' and filetype($empty_dir.$f) == "file")
				{
					unlink($empty_dir.$f);
				}
				elseif ( $f > '0' and filetype($empty_dir.$f) == "dir" )
				{
					remove_dir($current_dir.$f."\\");
				}
			}
			closedir($dir);
			rmdir($current_dir);
		}
	}

	/**
	* Post download announcement
	*/
	function create_announcement($download_subject, $download_msg, $forum_id)
	{
		global $db, $phpbb_root_path, $phpEx;

		if (!function_exists('submit_post'))
		{
			include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
		}

		$subject =  utf8_normalize_nfc($download_subject);
		$text =  utf8_normalize_nfc($download_msg);

		// Do not try to post message if subject or text is empty
		if (empty($subject) || empty($text))
		{
			return;
		}

		// variables to hold the parameters for submit_post
		$poll = $uid = $bitfield = $options = '';

		generate_text_for_storage($subject, $uid, $bitfield, $options, false, false, false);
		generate_text_for_storage($text, $uid, $bitfield, $options, true, true, true);

		$data = array(
			'forum_id'        	=> $forum_id,
			'icon_id'       	=> false,

			'enable_bbcode'     => true,
			'enable_smilies'    => true,
			'enable_urls'       => true,
			'enable_sig'        => true,

			'message'        	=> $text,
			'message_md5'    	=> md5($text),

			'bbcode_bitfield'   => $bitfield,
			'bbcode_uid'        => $uid,

			'post_edit_locked'	=> 0,
			'topic_title'       => $subject,
			'notify_set'        => false,
			'notify'            => false,
			'post_time'         => 0,
			'forum_name'        => '',
			'enable_indexing'   => true,
		);

		submit_post('post', $subject, '', POST_NORMAL, $poll, $data);
	}
}

?>