<?php
/**
*
* @package acp
* @version $Id: acp_dm_linkx.php 134 2010-08-19 06:03:30Z femu $
* @copyright (c) 2009 femu - http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* Here we start the ACP panel
*/
class acp_dm_linkx
{
	var $u_action;
	function main($id, $mode)
	{
		// Let's first set some globals, includes, variables and the base template
		global $db, $user, $phpbb_root_path, $phpEx, $template, $u_action, $SID,  $config;
		$dm_linkx_path = (defined('DM_LINKX_ROOT_PATH')) ? DM_LINKX_ROOT_PATH : 'dm_linkx/';
		include($phpbb_root_path . $dm_linkx_path . 'functions_acp_dm_linkx.' . $phpEx);

		$action = request_var('action', '');
		$id		= request_var('id', 0);
		$form_action = $this->u_action. '&amp;action=add';
		$lang_mode = $user->lang['DM_LINKX_ADD'];

		$template->assign_vars(array(
			'BASE'		=> $this->u_action,
		));

		// Here we set the main switches to use within the ACP
		switch ($mode)
		{
			// Set the main switch for managing categories
			case 'manage_categories':
				$this->page_title = 'ACP_DM_LINKX_MANAGE_CATEGORIES';
				$this->tpl_name = 'acp_dm_linkx_main';

				// Now let's define, what to do within the module Manage Categories
				switch ($action)
				{
					// Create a new category
					case 'create':
						$title = 'DM_LINKX_DM_LINKX_ACP_CATSN';
						$this->page_title = $user->lang[$title];

						$this->create_cat();
					break;

					// Edit an existing category
					case 'edit':
						$title = 'DM_LINKX_DM_LINKX_ACP_CATSE';
						$this->page_title = $user->lang[$title];

						$this->edit_cat();
					break;

					// Delete an existing category
					case 'delete':
						$title = 'DM_LINKX_DM_LINKX_ACP_CATSD';
						$this->page_title = $user->lang[$title];

						$this->delete_cat();
					break;

					// Move a category to another position
					case 'move':
						$this->move_cat();
					break;

					// Call the main module
					default:
						$title = 'ACP_DM_LINKX_MANAGE_CATEGORIES';
						$this->page_title = $user->lang[$title];

						$this->manage_cats();
					break;
				}
			break;

			// Set the main switch for editing linkxs
			case 'edit_linkxs':
				$this->page_title = 'ACP_DM_LINKX_EDIT';
				$this->tpl_name = 'acp_dm_linkx_list';

				$form_name = 'linkx_edit';
				add_form_key($form_name);

				$start = request_var('start', 0);
				$number = 20;
				$sort_days	= request_var('st', 0);
				$sort_key	= request_var('sk', 'linkx_title');
				$sort_dir	= request_var('sd', 'ASC');
				$limit_days = array(0 => $user->lang['DM_LINKX_ALL_LINKXS'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);

				$sort_by_text = array('t' => $user->lang['DM_LINKX_SORT_TITLE'], 'u' => $user->lang['DM_LINKX_SORT_FROMNAME'], 'c' => $user->lang['DM_LINKX_SORT_CAT'], 'ap' => $user->lang['DM_LINKX_SORT_APPROVAL']);
				$sort_by_sql = array('t' => 'linkx_title', 'u' => 'linkx_username', 'c' => 'linkx_cat_id', 'ap' => 'linkx_approval');

				$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
				gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);
				$sql_sort_order = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

				// Count number of linkxs
				$sql = 'SELECT COUNT(linkx_id) AS total_linkxs
					FROM ' . DM_LINKX_TABLE;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$total_linkxs = $row['total_linkxs'];
				$db->sql_freeresult($result);

				// List all linkxs
				$sql = 'SELECT v.*, c.*
					FROM ' . DM_LINKX_TABLE . ' v
					LEFT JOIN ' . DM_LINKX_CATS_TABLE . ' c
						ON v.linkx_cat_id = c.cat_id
					ORDER by v.'. $sql_sort_order;
				$result = $db->sql_query_limit($sql, $number, $start);

				while ($row = $db->sql_fetchrow($result))
				{
					$template->assign_block_vars('linkxs', array(
						'TITLE'			=> $row['linkx_title'],
						'DESC'			=> $row['linkx_desc'],
						'LINK'			=> $row['linkx_link'],
						'USERNAME'		=> $row['linkx_username'],
						'APPROVAL'		=> ($row['linkx_approval']) ? $user->lang['YES'] : $user->lang['NO'],
						'CATNAME'		=> $row['cat_name'],
						'U_EDIT'		=> $this->u_action . '&amp;action=edit&amp;id=' . $row['linkx_id'],
						'U_DEL'			=> $this->u_action . '&amp;action=delete&amp;id=' . $row['linkx_id'],
						'U_LINKX_PLAY'	=> append_sid("{$phpbb_root_path}{$dm_linkx_path}showlinkx.$phpEx", "v={$row['linkx_id']}&amp;c={$row['linkx_cat_id']}"),
						)
					);
				}
				$db->sql_freeresult($result);

				$template->assign_vars(array(
					'S_LINKX_ACTION' 	=> $this->u_action,
					'S_SELECT_SORT_DIR'	=> $s_sort_dir,
					'S_SELECT_SORT_KEY'	=> $s_sort_key,
					'PAGINATION' 		=> generate_pagination($this->u_action . '&amp;sk=' . $sort_key .'&amp;sd=' . $sort_dir, $total_linkxs, $number, $start),
					'L_MODE_TITLE'		=> $lang_mode,
					'U_EDIT_ACTION'		=> $this->u_action,
					'PAGE_NUMBER'		=> on_page($total_linkxs, $number, $start),
					'TOTAL_LINKXS'		=> ($total_linkxs == 1) ? $user->lang['DM_LINKX_SINGLE'] : sprintf($user->lang['DM_LINKX_MULTI'], $total_linkxs),
				));

				// Now let's define, what to do within the module Edit Linkxs
				switch ($action)
				{
					// Edit an existing linkx
					case 'edit':
						$this->page_title = 'ACP_DM_LINKX_EDIT';
						$this->tpl_name = 'acp_dm_linkx_edit';
						$form_action = $this->u_action. '&amp;action=update';
						$lang_mode = $user->lang['ACP_DM_LINKX_EDIT'];

						$action = (!isset($_GET['action'])) ? '' : $_GET['action'];
						$action = ((isset($_POST['submit']) && !$_POST['id']) ? 'add' : $action );

						$id = request_var('id', '');

						$sql = 'SELECT *
							FROM ' . DM_LINKX_TABLE . '
							WHERE linkx_id = ' . $id;
						$result = $db->sql_query_limit($sql,1);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);
						decode_message($row['linkx_desc'], $row['bbcode_uid']);
						$linkx_id = $row['linkx_id'];

						$sql = 'SELECT *
							FROM ' . DM_LINKX_CATS_TABLE . '
							ORDER BY cat_name';
						$result = $db->sql_query($sql);
						$cats = array();
						while ($row2 = $db->sql_fetchrow($result))
						{
							$cats[$row2['cat_id']] = array(
								'cat_name'	=> $row2['cat_name'],
								'cat_id'	=> $row2['cat_id'],
							);
						}
						$db->sql_freeresult($result);

						$options = '';
						foreach($cats as $key => $value)
						{
							if ($key == $row['linkx_cat_id'])
							{
								$options .= '<option value="' . $value['cat_id'] . '" selected="selected">' . $value['cat_name'] . '</option>';
							}
							else
							{
								$options .= '<option value="' . $value['cat_id'] . '">' . $value['cat_name'] . '</option>';
							}
						}

						$template->assign_vars(array(
							'ID'				=> $linkx_id,
							'TITLE'				=> $row['linkx_title'],
							'DESC'				=> $row['linkx_desc'],
							'LINK'				=> $row['linkx_link'],
							'LINKX_IMAGE'		=> $row['linkx_image'],
							'USERNAME'			=> $row['linkx_username'],
							'APPROVAL'			=> ($row['linkx_approval'] == '1') ? 'checked="checked"' : '',
							'PARENT_OPTIONS'	=> $options,
							)
						);

						$template->assign_vars(array(
							'U_ACTION'		=> $form_action,
							'L_MODE_TITLE'	=> $lang_mode,
							)
						);
					break;

					// Change an existing linkx
					case 'update':
						$title 		= utf8_normalize_nfc(request_var('title', '', true));
						$link 		= request_var('link', '');
						$approval	= request_var('approval', 0);
						$image		= request_var('linkx_image', '');
						$v_cat_id	= request_var('parent', '');

						$desc 		= utf8_normalize_nfc(request_var('desc', '', true));

						$uid = $bitfield = $options = ''; // will be modified by generate_text_for_storage
						$allow_bbcode = $allow_urls = $allow_smilies = true;
						generate_text_for_storage($desc, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);

						$sql_ary = array(
							'linkx_title'		=> $title,
							'linkx_desc'		=> $desc,
							'linkx_link'		=> $link,
							'linkx_image'		=> $image,
							'linkx_approval'	=> $approval,
							'linkx_cat_id'		=> $v_cat_id,
							'bbcode_uid'		=> $uid,
							'bbcode_bitfield'	=> $bitfield,
							'bbcode_options'	=> $options,
						);

						if ($title == '' || $link == '')
						{
							if ($title == '' && $link == '')
							{
								trigger_error($user->lang['DM_LINKX_NEED_DATA'] . adm_back_link($this->u_action));
							}
							elseif ($title == '')
							{
								trigger_error($user->lang['DM_LINKX_NEED_TITLE'] . adm_back_link($this->u_action));
							}
							elseif ($link == '')
							{
								trigger_error($user->lang['DM_LINKX_NEED_URL'] . adm_back_link($this->u_action));
							}
						}
						else
						{
							if (!check_form_key($form_name))
							{
								trigger_error($user->lang['FORM_INVALID']. adm_back_link($this->u_action), E_USER_WARNING);
							}

							$db->sql_query('UPDATE ' . DM_LINKX_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . ' WHERE linkx_id = ' . $id);
							trigger_error($user->lang['DM_LINKX_UPDATED'] . adm_back_link($this->u_action));
						}
					break;

					// Delete an existing linkx
					case 'delete':
						if (confirm_box(true))
						{
							$sql = 'DELETE FROM ' . DM_LINKX_TABLE . '
								WHERE linkx_id = '. $id;
							$db->sql_query($sql);
							trigger_error($user->lang['DM_LINKX_DELETED'] . adm_back_link($this->u_action));
						}
						else
						{
							confirm_box(false, $user->lang['DM_LINKX_REALY_DELETE'], build_hidden_fields(array(
								'linkx_id'	=> $id,
								'action'	=> 'delete',
								))
							);
						}
					break;
				}

			break;

			// Set the main switch to handle reported linkxs
			case 'reported_linkxs':
				$this->page_title = 'ACP_DM_LINKX_REPORTED';
				$this->tpl_name = 'acp_dm_linkx_reported';

				$form_name = 'linkx_reported';
				add_form_key($form_name);

				// List all linkxs, which are reported as broken
				$sql = 'SELECT *
					FROM ' . DM_LINKX_TABLE . '
					WHERE linkx_reported = 1
					ORDER by linkx_title';
				$result = $db->sql_query($sql);

				while ($row = $db->sql_fetchrow($result))
				{
					$template->assign_block_vars('linkxs', array(
						'TITLE'			=> $row['linkx_title'],
						'DESC'			=> $row['linkx_desc'],
						'LINK'			=> $row['linkx_link'],
						'USERNAME'		=> $row['linkx_username'],
						'REPORTED'		=> ($row['linkx_reported']) ? $user->lang['YES'] : $user->lang['NO'],
						'U_EDIT'		=> $this->u_action . '&amp;action=edit&amp;id=' .$row['linkx_id'],
						'U_DEL'			=> $this->u_action . '&amp;action=delete&amp;id=' .$row['linkx_id'],
						'U_LINKX_PLAY'	=> append_sid("{$phpbb_root_path}{$dm_linkx_path}showlinkx.$phpEx", "v={$row['linkx_id']}&amp;c={$row['linkx_cat_id']}"),
						)
					);
				}
				$db->sql_freeresult($result);

				$template->assign_vars(array(
					'U_ACTION'		=> $form_action,
					'L_MODE_TITLE'	=> $lang_mode,
					)
				);

				// Now let's define, what to do within the module Release Linkxs
				switch ($action)
				{
					// Edit an existing linkx
					case 'edit':
						$this->page_title = 'ACP_DM_LINKX_REPORTED_EDIT';
						$this->tpl_name = 'acp_dm_linkx_reported_edit';

						$form_action = $this->u_action. '&amp;action=update';
						$lang_mode = $user->lang['ACP_DM_LINKX_REPORTED_EDIT'];

						$action = (!isset($_GET['action'])) ? '' : $_GET['action'];
						$action = ((isset($_POST['submit']) && !$_POST['id']) ? 'add' : $action );

						$id = request_var('id', 0);

						$sql = 'SELECT *
							FROM ' . DM_LINKX_TABLE . '
							WHERE linkx_id = ' . $id;
						$result = $db->sql_query_limit($sql,1);
						$row = $db->sql_fetchrow($result);
						decode_message($row['linkx_title'], $row['linkx_desc'], $row['linkx_link']);
						$linkx_id = $row['linkx_id'];

						$template->assign_vars(array(
							'ID'			=> $linkx_id,
							'TITLE'			=> $row['linkx_title'],
							'REPORTED'		=> ($row['linkx_reported'] == '1') ? '' : 'checked="checked"',
							)
						);

						$db->sql_freeresult($result);

						$template->assign_vars(array(
							'U_ACTION'		=> $form_action,
							'L_MODE_TITLE'	=> $lang_mode,
							)
						);
					break;

					// Change an existing linkx
					case 'update':
						$title 	= request_var('title', '');
						$link 	= request_var('link', '');
						$sql_ary = array(
							'linkx_reported'	=> request_var('reported', 0),
							'linkx_approval'	=> request_var('approval', 0),
						);

						if (!check_form_key($form_name))
						{
							trigger_error($user->lang['FORM_INVALID']. adm_back_link($this->u_action), E_USER_WARNING);
						}

						$db->sql_query('UPDATE ' . DM_LINKX_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . ' WHERE linkx_id = ' . $id);
							trigger_error($user->lang['DM_LINKX_UPDATED'] . adm_back_link($this->u_action));
					break;

					// Delete an existing linkx
					case 'delete':
						if (confirm_box(true))
						{
							$sql = 'DELETE FROM ' . DM_LINKX_TABLE . '
								WHERE linkx_id = '. $id;
							$db->sql_query($sql);
							trigger_error($user->lang['DM_LINKX_DELETED'] . adm_back_link($this->u_action));
						}
						else
						{
							confirm_box(false, $user->lang['DM_LINKX_REALY_DELETE'], build_hidden_fields(array(
								'linkx_id'	=> $id,
								'action'	=> 'delete',
								))
							);
						}
					break;
				}
			break;

			// Set the main switch for releasing linkxs
			case 'release_linkxs':
				$this->page_title = 'ACP_DM_LINKX_RELEASE';
				$this->tpl_name = 'acp_dm_linkx_release';

				$form_name = 'linkx_release';
				add_form_key($form_name);

				// List all linkxs, which are not yet released
				$sql = 'SELECT *
					FROM ' . DM_LINKX_TABLE . '
					WHERE linkx_approval = 0
					ORDER by linkx_title';
				$result = $db->sql_query($sql);

				while ($row = $db->sql_fetchrow($result))
				{
					$template->assign_block_vars('linkxs', array(
						'TITLE'			=> $row['linkx_title'],
						'DESC'			=> $row['linkx_desc'],
						'LINK'			=> $row['linkx_link'],
						'USERNAME'		=> $row['linkx_username'],
						'APPROVAL'		=> ($row['linkx_approval']) ? $user->lang['YES'] : $user->lang['NO'],
						'U_EDIT'		=> $this->u_action . '&amp;action=edit&amp;id=' .$row['linkx_id'],
						'U_DEL'			=> $this->u_action . '&amp;action=delete&amp;id=' .$row['linkx_id'],
						'U_LINKX_PLAY'	=> append_sid("{$phpbb_root_path}{$dm_linkx_path}showlinkx.$phpEx", "v={$row['linkx_id']}&amp;c={$row['linkx_cat_id']}"),
						)
					);
				}
				$db->sql_freeresult($result);

				$template->assign_vars(array(
					'U_ACTION'		=> $form_action,
					'L_MODE_TITLE'	=> $lang_mode,
					)
				);

				// Now let's define, what to do within the module Release Linkxs
				switch ($action)
				{
					// Edit an existing linkx
					case 'edit':
						$this->page_title = 'ACP_DM_LINKX_RELEASE_EDIT';
						$this->tpl_name = 'acp_dm_linkx_release_edit';
						$form_action = $this->u_action. '&amp;action=update';
						$lang_mode = $user->lang['ACP_DM_LINKX_RELEASE_EDIT'];
						$action = (!isset($_GET['action'])) ? '' : $_GET['action'];
						$action = ((isset($_POST['submit']) && !$_POST['id']) ? 'add' : $action );
						$id = request_var('id', '');
						$sql = 'SELECT *
							FROM ' . DM_LINKX_TABLE . '
							WHERE linkx_id = ' . $id;
						$result = $db->sql_query_limit($sql,1);
						$row = $db->sql_fetchrow($result);
						decode_message($row['linkx_title'], $row['linkx_desc'], $row['linkx_link']);
						$linkx_id = $row['linkx_id'];
						$template->assign_vars(array(
							'ID'			=> $linkx_id,
							'TITLE'			=> $row['linkx_title'],
							'APPROVAL'		=> ($row['linkx_approval'] == '1') ? 'checked="checked"' : '',
							)
						);

						$db->sql_freeresult($result);

						$template->assign_vars(array(
							'U_ACTION'		=> $form_action,
							'L_MODE_TITLE'	=> $lang_mode,
							)
						);
					break;

					// Change an existing linkx
					case 'update':
						$title 	= request_var('title', '');
						$link 	= request_var('link', '');
						$sql_ary = array(
							'linkx_approval'	=> request_var('approval', 0),
						);

						if (!check_form_key($form_name))
						{
							trigger_error($user->lang['FORM_INVALID']. adm_back_link($this->u_action), E_USER_WARNING);
						}

						$db->sql_query('UPDATE ' . DM_LINKX_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . ' WHERE linkx_id = ' . $id);
						trigger_error($user->lang['DM_LINKX_UPDATED'] . adm_back_link($this->u_action));
					break;

					// Delete an existing linkx
					case 'delete':
						if (confirm_box(true))
						{
							$sql = 'DELETE FROM ' . DM_LINKX_TABLE . '
								WHERE linkx_id = '. $id;
							$db->sql_query($sql);
							trigger_error($user->lang['DM_LINKX_DELETED'] . adm_back_link($this->u_action));
						}
						else
						{
							confirm_box(false, $user->lang['DM_LINKX_REALY_DELETE'], build_hidden_fields(array(
								'linkx_id'	=> $id,
								'action'	=> 'delete',
								))
							);
						}
					break;
				}
			break;

			// Set the main switch for the config
			case 'linkx_config':
				$submit = (isset($_POST['submit'])) ? true: false;
				$this->page_title = 'ACP_DM_LINKX_CONFIG';
				$this->tpl_name = 'acp_dm_linkx_config';

				$form_name = 'config_edit';
				add_form_key($form_name);

				if($submit == true)
				{
					if (!check_form_key($form_name))
					{
						trigger_error($user->lang['FORM_INVALID']. adm_back_link($this->u_action), E_USER_WARNING);
					}

					$sql = "SELECT *
						FROM " . DM_LINKX_CONFIG_TABLE;
					$result = $db->sql_query($sql);
					while($row = $db->sql_fetchrow($result))
					{
						$config_name = $row['config_name'];
						$config_value = request_var($config_name, '', true);
						$sql = 'UPDATE ' . DM_LINKX_CONFIG_TABLE . " SET
							config_value = '$config_value'
							WHERE config_name = '$config_name'";
						$db->sql_query($sql);
					}
					trigger_error($user->lang['DM_LINKX_CONFIG_UPDATED'] . adm_back_link($this->u_action));
				}

				$sql = 'SELECT config_name, config_value
					FROM ' . DM_LINKX_CONFIG_TABLE;
				$result = $db->sql_query($sql);
				while($row = $db->sql_fetchrow($result))
				{
					$new[$row['config_name']] = $row['config_value'];
				}

				$template->assign_vars(array(
					'ROWS_PER_PAGE_ACP'		=> $new['linkx_page_acp'],
					'ROWS_PER_PAGE_USER'	=> $new['linkx_page_user'],
					'TOP_VIEWS'				=> $new['top_views'],
					'TOP_RATING'			=> $new['top_ratings'],
					'NEWEST_LINKXS'			=> $new['newest_linkxs'],
					'ROWS_PER_PAGE_COMMENT' => $new['linkx_page_comment'],
					'L_MODE_TITLE'			=> $lang_mode,
					'U_ACTION'				=> $this->u_action,
				));
			break;
		}
	}


	/**
	* Define all the functions, which are used above
	*/

	/**
	* Function for managing categories
	*/
	function manage_cats()
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_admin_path, $phpbb_root_path, $phpEx;
		$catrow = array();
		$parent_id = request_var('parent_id', 0);
		$template->assign_vars(array(
			'S_MODE_MANAGE'	=> true,
			'S_ACTION'		=> $this->u_action . '&amp;action=create&amp;parent_id=' . $parent_id,
		));
		if (!$parent_id)
		{
			$navigation = $user->lang['DM_LINKX_DM_LINKX_INDEX'];
		}
		else
		{
			$navigation = '<a href="' . $this->u_action . '">' . $user->lang['DM_LINKX_DM_LINKX_INDEX'] . '</a>';

			$dm_linkx_nav = get_cat_branch($parent_id, 'parents', 'descending');
			foreach ($dm_linkx_nav as $row)
			{
				if ($row['cat_id'] == $parent_id)
				{
					$navigation .= ' -&gt; ' . $row['cat_name'];
				}
				else
				{
					$navigation .= ' -&gt; <a href="' . $this->u_action . '&amp;parent_id=' . $row['cat_id'] . '">' . $row['cat_name'] . '</a>';
				}
			}
		}
		$dm_linkx = array();
		$sql = 'SELECT *
			FROM ' . DM_LINKX_CATS_TABLE . '
			WHERE parent_id = ' . $parent_id . '
			ORDER BY left_id ASC';
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$dm_linkx[] = $row;
		}

		for( $i = 0; $i < count($dm_linkx); $i++ )
		{
			$folder_image = ($dm_linkx[$i]['left_id'] + 1 != $dm_linkx[$i]['right_id']) ? '<img src="images/icon_subfolder.gif" alt="' . $user->lang['SUBFORUM'] . '" />' : '<img src="images/icon_folder.gif" alt="' . $user->lang['FOLDER'] . '" />';
			$template->assign_block_vars('catrow', array(
				'FOLDER_IMAGE'			=> $folder_image,
				'U_CAT'					=> $this->u_action . '&amp;parent_id=' . $dm_linkx[$i]['cat_id'],
				'CAT_NAME'				=> $dm_linkx[$i]['cat_name'],
				'CAT_DESCRIPTION'		=> generate_text_for_display($dm_linkx[$i]['cat_desc'], $dm_linkx[$i]['cat_desc_uid'], $dm_linkx[$i]['cat_desc_bitfield'], $dm_linkx[$i]['cat_desc_options']),
				'U_MOVE_UP'				=> $this->u_action . '&amp;action=move&amp;move=move_up&amp;cat_id=' . $dm_linkx[$i]['cat_id'],
				'U_MOVE_DOWN'			=> $this->u_action . '&amp;action=move&amp;move=move_down&amp;cat_id=' . $dm_linkx[$i]['cat_id'],
				'U_EDIT'				=> $this->u_action . '&amp;action=edit&amp;cat_id=' . $dm_linkx[$i]['cat_id'],
				'U_DELETE'				=> $this->u_action . '&amp;action=delete&amp;cat_id=' . $dm_linkx[$i]['cat_id'],
			));
		}
		$template->assign_vars(array(
			'NAVIGATION'		=> $navigation,
			'S_DM_LINKX'		=> $parent_id,
			'U_EDIT'			=> ($parent_id) ? $this->u_action . '&amp;action=edit&amp;cat_id=' . $parent_id : '',
			'U_DELETE'			=> ($parent_id) ? $this->u_action . '&amp;action=delete&amp;cat_id=' . $parent_id : '',
		));
	}

	/**
	* Function for create a category
	*/
	function create_cat()
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_admin_path, $phpbb_root_path, $phpEx;

		$form_name = 'create_categories';
		add_form_key($form_name);

		require($phpbb_root_path . 'includes/message_parser.' . $phpEx);
		$submit = (isset($_POST['submit'])) ? true : false;
		if($submit)
		{
			if (!check_form_key($form_name))
			{
				trigger_error($user->lang['FORM_INVALID']. adm_back_link($this->u_action), E_USER_WARNING);
			}

			$dm_linkx_data = array();
			$dm_linkx_data = array(
				'cat_name'						=> request_var('cat_name', '', true),
				'parent_id'						=> request_var('parent_id', 0),

				'cat_parents'					=> '',
				'cat_desc'						=>  utf8_normalize_nfc(request_var('cat_desc', '', true)),
				'cat_desc_options'				=> 7,
			);
			generate_text_for_storage($dm_linkx_data['cat_desc'], $dm_linkx_data['cat_desc_uid'], $dm_linkx_data['cat_desc_bitfield'], $dm_linkx_data['cat_desc_options'], request_var('desc_parse_bbcode', false), request_var('desc_parse_urls', false), request_var('desc_parse_smilies', false));

			if ($dm_linkx_data['parent_id'])
			{
				$sql = 'SELECT left_id, right_id
					FROM ' . DM_LINKX_CATS_TABLE . '
					WHERE cat_id = ' . $dm_linkx_data['parent_id'];
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				if (!$row)
				{
					trigger_error($user->lang['PARENT_NOT_EXIST'] . adm_back_link($this->u_action . '&amp;' . $this->parent_id), E_USER_WARNING);
				}

				$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . '
					SET left_id = left_id + 2, right_id = right_id + 2
					WHERE left_id > ' . $row['right_id'];
				$db->sql_query($sql);

				$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . '
					SET right_id = right_id + 2
					WHERE ' . $row['left_id'] . ' BETWEEN left_id AND right_id';
				$db->sql_query($sql);

				$dm_linkx_data['left_id'] = $row['right_id'];
				$dm_linkx_data['right_id'] = $row['right_id'] + 1;
			}
			else
			{
				$sql = 'SELECT MAX(right_id) AS right_id
					FROM ' . DM_LINKX_CATS_TABLE;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				$dm_linkx_data['left_id'] = $row['right_id'] + 1;
				$dm_linkx_data['right_id'] = $row['right_id'] + 2;
			}
			$db->sql_query('INSERT INTO ' . DM_LINKX_CATS_TABLE . ' ' . $db->sql_build_array('INSERT', $dm_linkx_data));
			$cache->destroy('sql', DM_LINKX_CATS_TABLE);

			trigger_error($user->lang['DM_LINKX_CAT_NEW_DONE'] . adm_back_link($this->u_action . '&amp;parent_id=' . $dm_linkx_data['parent_id']));
		}
		$parent_options = make_cat_select(request_var('parent_id', 0), false, false, false, false);
		$template->assign_vars(array(
			'S_MODE_CREATE'				=> true,

			'S_ACTION'					=> $this->u_action . '&amp;parent_id=' . request_var('parent_id', 0),
			'S_DESC_BBCODE_CHECKED'		=> true,
			'S_DESC_SMILIES_CHECKED'	=> true,
			'S_DESC_URLS_CHECKED'		=> true,
			'S_PARENT_OPTIONS'			=> $parent_options,
		));
	}

	/**
	* Function for editing a category
	*/
	function edit_cat()
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_admin_path, $phpbb_root_path, $phpEx;
		require($phpbb_root_path . 'includes/message_parser.' . $phpEx);

		$form_name = 'edit_categories';
		add_form_key($form_name);

		if (!$cat_id = request_var('cat_id', 0))
		{
			trigger_error('No Cat ID', E_USER_WARNING);
		}

		$submit = (isset($_POST['submit'])) ? true : false;
		if($submit)
		{
			if (!check_form_key($form_name))
			{
				trigger_error($user->lang['FORM_INVALID']. adm_back_link($this->u_action), E_USER_WARNING);
			}

			$dm_linkx_data = array();
			$dm_linkx_data = array(
				'cat_name'						=> request_var('cat_name', '', true),
				'parent_id'						=> request_var('parent_id', 0),

				'cat_parents'					=> '',
				'cat_desc_options'				=> 7,
				'cat_desc'						=> utf8_normalize_nfc(request_var('cat_desc', '', true)),
			);
			generate_text_for_storage($dm_linkx_data['cat_desc'], $dm_linkx_data['cat_desc_uid'], $dm_linkx_data['cat_desc_bitfield'], $dm_linkx_data['cat_desc_options'], request_var('desc_parse_bbcode', false), request_var('desc_parse_urls', false), request_var('desc_parse_smilies', false));
			$row = get_cat_info($cat_id);
			if ($row['parent_id'] != $dm_linkx_data['parent_id'])
			{
				//how many do we have to move and how far
				$moving_ids = ($row['right_id'] - $row['left_id']) + 1;
				$sql = 'SELECT MAX(right_id) AS right_id
					FROM ' . DM_LINKX_CATS_TABLE;
				$result = $db->sql_query($sql);
				$highest = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
				$moving_distance = ($highest['right_id'] - $row['left_id']) + 1;
				$stop_updating = $moving_distance + $row['left_id'];

				//update the moving linkx... move it to the end
				$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . '
					SET right_id = right_id + ' . $moving_distance . ',
						left_id = left_id + ' . $moving_distance . '
					WHERE left_id >= ' . $row['left_id'] . '
						AND right_id <= ' . $row['right_id'];
				$db->sql_query($sql);
				$new['left_id'] = $row['left_id'] + $moving_distance;
				$new['right_id'] = $row['right_id'] + $moving_distance;

				//close the gap, we got
				if ($dm_linkx_data['parent_id'] == 0)
				{//we move to root
					//left_id
					$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . '
						SET left_id = left_id - ' . $moving_ids . '
						WHERE left_id >= ' . $row['left_id'];
					$db->sql_query($sql);
					//right_id
					$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . '
						SET right_id = right_id - ' . $moving_ids . '
						WHERE right_id >= ' . $row['left_id'];
					$db->sql_query($sql);
				}
				else
				{
					//close the gap
					//left_id
					$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . '
						SET left_id = left_id - ' . $moving_ids . '
						WHERE left_id >= ' . $row['left_id'] . '
							AND right_id <= ' . $stop_updating;
					$db->sql_query($sql);
					//right_id
					$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . '
						SET right_id = right_id - ' . $moving_ids . '
						WHERE right_id >= ' . $row['left_id'] . '
							AND right_id <= ' . $stop_updating;
					$db->sql_query($sql);

					//create new gap
					//need parent_information
					$parent = get_cat_info($dm_linkx_data['parent_id']);
					//left_id
					$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . '
						SET left_id = left_id + ' . $moving_ids . '
						WHERE left_id >= ' . $parent['right_id'] . '
							AND right_id <= ' . $stop_updating;
					$db->sql_query($sql);
					//right_id
					$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . '
						SET right_id = right_id + ' . $moving_ids . '
						WHERE right_id >= ' . $parent['right_id'] . '
							AND right_id <= ' . $stop_updating;
					$db->sql_query($sql);

					//close the gap again
					//new parent right_id!!!
					$parent['right_id'] = $parent['right_id'] + $moving_ids;
					$move_back = ($new['right_id'] - $parent['right_id']) + 1;
					$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . '
						SET left_id = left_id - ' . $move_back . ',
							right_id = right_id - ' . $move_back . '
						WHERE left_id >= ' . $stop_updating;
					$db->sql_query($sql);
				}
			}
			if ($row['cat_name'] != $dm_linkx_data['cat_name'])
			{
				// the forum name has changed, clear the parents list of all forums (for safety)
				$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . "
					SET cat_parents = ''";
				$db->sql_query($sql);
			}
			$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . '
					SET ' . $db->sql_build_array('UPDATE', $dm_linkx_data) . '
					WHERE cat_id  = ' . (int) $cat_id;
			$db->sql_query($sql);
			$cache->destroy('sql', DM_LINKX_CATS_TABLE);

			trigger_error($user->lang['DM_LINKX_CAT_EDIT_DONE'] . adm_back_link($this->u_action . '&amp;parent_id=' . $dm_linkx_data['parent_id']));
		}
		$sql = 'SELECT *
			FROM ' . DM_LINKX_CATS_TABLE . "
			WHERE cat_id = '$cat_id'";
		$result = $db->sql_query($sql);
		if ($db->sql_affectedrows($result) == 0)
		{
			trigger_error('The requested cat does not exist', E_USER_WARNING);
		}
		$dm_linkx_data = $db->sql_fetchrow($result);
		$dm_linkx_desc_data = generate_text_for_edit($dm_linkx_data['cat_desc'], $dm_linkx_data['cat_desc_uid'], $dm_linkx_data['cat_desc_options']);
		$parents_list = make_cat_select($dm_linkx_data['parent_id'], $cat_id);

		$template->assign_vars(array(
			'S_MODE_EDIT'				=> true,

			'S_ACTION'					=> $this->u_action . '&amp;action=edit&amp;cat_id=' . $cat_id,
			'S_PARENT_OPTIONS'			=> $parents_list,

			'CAT_NAME'					=> $dm_linkx_data['cat_name'],
			'CAT_DESC'					=> $dm_linkx_desc_data['text'],
			'S_DESC_BBCODE_CHECKED'		=> ($dm_linkx_desc_data['allow_bbcode']) ? true : false,
			'S_DESC_SMILIES_CHECKED'	=> ($dm_linkx_desc_data['allow_smilies']) ? true : false,
			'S_DESC_URLS_CHECKED'		=> ($dm_linkx_desc_data['allow_urls']) ? true : false,

			'S_MODE'				=> 'edit',
		));
	}

	/**
	* Function for deleting a category
	*/
	function delete_cat()
	{
		global $db, $template, $user, $cache;

		if (!$cat_id = request_var('cat_id', 0))
		{
			trigger_error('No Cat ID', E_USER_WARNING);
		}
		else
		{
			$sql = 'SELECT *
				FROM ' . DM_LINKX_CATS_TABLE . "
				WHERE cat_id = '$cat_id'";
			$result = $db->sql_query($sql);
			if ($db->sql_affectedrows($result) == 0)
			{
				trigger_error($user->lang['DM_LINKX_CAT_NOT_EXISTS'], E_USER_WARNING);
			}
		}

		$submit = (isset($_POST['submit'])) ? true : false;

		if (confirm_box(true))
		{
			$dm_linkx = get_cat_info($cat_id);
			$handle_subs = request_var('handle_subs', 0);
			if (($dm_linkx['right_id'] - $dm_linkx['left_id']) > 2)
			{//handle subs if there
				//we have to learn how to delete or move the subs
				if ($handle_subs >= 0)
				{
					trigger_error($user->lang['DM_LINKX_DELETE_SUB_CATS'] . adm_back_link($this->u_action), E_USER_WARNING);
				}
			}

			// Check if category has links
			$sql = ' SELECT COUNT(linkx_id) AS has_links
				FROM ' . DM_LINKX_TABLE . '
				WHERE linkx_cat_id = ' . $cat_id;
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$has_links = $row['has_links'];
			$db->sql_freeresult($result);

			if ( $has_links > 0 )
			{
				trigger_error($user->lang['DM_LINKX_DELETE_HAS_FILES'] . adm_back_link($this->u_action), E_USER_WARNING);
			}

			//reorder the other linkxs
			//left_id
			$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . '
				SET left_id = left_id - 2
				WHERE left_id > ' . $dm_linkx['left_id'];
			$db->sql_query($sql);
			//right_id
			$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . '
				SET right_id = right_id - 2
				WHERE right_id > ' . $dm_linkx['left_id'];
			$db->sql_query($sql);
			$sql = 'DELETE FROM ' . DM_LINKX_CATS_TABLE . "
				WHERE cat_id = '$cat_id'";
			$result = $db->sql_query($sql);
			$cache->destroy('sql', DM_LINKX_CATS_TABLE);
			trigger_error($user->lang['DM_LINKX_CAT_DELETE_DONE'] . adm_back_link($this->u_action));

			$catname = '';
			$sql = 'SELECT ec.*, COUNT(ed.linkx_id) AS links
				FROM ' . DM_LINKX_CATS_TABLE . ' AS ec
				LEFT JOIN ' . DM_LINKX_TABLE . ' AS ed
					ON ec.cat_id = ed.linkx_cat_id
				WHERE ec.cat_id = ' . $cat_id . '
				GROUP BY ec.cat_id';
			$result = $db->sql_query($sql);

			$subs_found = false;
			while($row = $db->sql_fetchrow($result))
			{
				if($row['cat_id'] == $cat_id)
				{
					$thislinkx = $row;
					$subs_found = true;
				}
				else
				{
					$linkxrow[] = $row;
				}
			}

			if(!$subs_found)
			{
				trigger_error($user->lang['DM_LINKX_CAT_NOT_EXISTS'], E_USER_WARNING);
			}
			$db->sql_freeresult($result);

			$template->assign_vars(array(
				'S_MODE_DELETE'		=> true,

				'S_DM_LINKX_ACTION'			=> $this->u_action . '&amp;action=delete&amp;dm_linkx_id=' . $cat_id,
				'DM_LINKX_DELETE'			=> sprintf($user->lang['DM_LINKX_DM_LINKX_ACP_CATSD'], $row['cat_name']),
				'S_PARENT_OPTIONS'			=> make_cat_select($thislinkx['parent_id'], $cat_id),
				'S_HAS_CHILDREN'			=> ($thislinkx['left_id'] + 1 != $thislinkx['right_id']) ? true : false,
				'CAT_NAME'					=> $thislinkx['cat_name'],
				'DM_LINKX_DESC'				=> generate_text_for_display($thislinkx['cat_desc'], $thislinkx['cat_desc_uid'], $thislinkx['cat_desc_bitfield'], $thislinkx['cat_desc_options']),
				'S_MOVE_DM_LINKX_OPTIONS'	=> make_cat_select(false, $cat_id),
				'S_MOVE_IMAGE_OPTIONS'		=> make_cat_select(false, $cat_id, true),
			));
		}
		else
		{
			$sql = 'SELECT cat_name
				FROM ' . DM_LINKX_CATS_TABLE . '
				WHERE cat_id = ' . $cat_id;
			$result = $db->sql_query($sql);
			$cat_name = $db->sql_fetchfield('cat_name');
			$db->sql_freeresult($result);

			$confirm_string = sprintf($user->lang['DM_LINKX_DEL_CAT'], $cat_name);
			confirm_box(false, $confirm_string);
		}
		redirect($this->u_action);
	}

	/**
	* Function for moving a category to another position
	*/
	function move_cat()
	{
		global $db, $user, $cache;

		if (!$cat_id = request_var('cat_id', 0))
		{
			trigger_error('No Cat ID', E_USER_WARNING);
		}
		else
		{
			$sql = 'SELECT *
				FROM ' . DM_LINKX_CATS_TABLE . "
				WHERE cat_id = '$cat_id'";
			$result = $db->sql_query($sql);
			if ($db->sql_affectedrows($result) == 0)
			{
				trigger_error('The requested category does not exist', E_USER_WARNING);
			}
		}
		$move = request_var('move', '', true);
		$moving = get_cat_info($cat_id);

		$sql = 'SELECT cat_id, left_id, right_id
			FROM ' . DM_LINKX_CATS_TABLE . "
			WHERE parent_id = {$moving['parent_id']}
				AND " . (($move == 'move_up') ? "right_id < {$moving['right_id']} ORDER BY right_id DESC" : "left_id > {$moving['left_id']} ORDER BY left_id ASC");
		$result = $db->sql_query_limit($sql, 1);

		$target = array();
		while ($row = $db->sql_fetchrow($result))
		{
			$target = $row;
		}
		$db->sql_freeresult($result);

		if (!sizeof($target))
		{
			// The forum is already on top or bottom
			return false;
		}

		if ($move == 'move_up')
		{
			$left_id = $target['left_id'];
			$right_id = $moving['right_id'];

			$diff_up = $moving['left_id'] - $target['left_id'];
			$diff_down = $moving['right_id'] + 1 - $moving['left_id'];

			$move_up_left = $moving['left_id'];
			$move_up_right = $moving['right_id'];
		}
		else
		{
			$left_id = $moving['left_id'];
			$right_id = $target['right_id'];

			$diff_up = $moving['right_id'] + 1 - $moving['left_id'];
			$diff_down = $target['right_id'] - $moving['right_id'];

			$move_up_left = $moving['right_id'] + 1;
			$move_up_right = $target['right_id'];
		}

		// Now do the dirty job
		$sql = 'UPDATE ' . DM_LINKX_CATS_TABLE . "
			SET left_id = left_id + CASE
				WHEN left_id BETWEEN {$move_up_left} AND {$move_up_right} THEN -{$diff_up}
				ELSE {$diff_down}
			END,
			right_id = right_id + CASE
				WHEN right_id BETWEEN {$move_up_left} AND {$move_up_right} THEN -{$diff_up}
				ELSE {$diff_down}
			END,
			cat_parents = ''
			WHERE
				left_id BETWEEN {$left_id} AND {$right_id}
				AND right_id BETWEEN {$left_id} AND {$right_id}";
		$db->sql_query($sql);
		$cache->destroy('sql', DM_LINKX_CATS_TABLE);
		redirect($this->u_action . '&amp;parent_id=' . $moving['parent_id']);
	}

	/**
	* Function for pagination
	*/
	function generate_page($replies, $url, $top)
	{
		global $config, $user;

		// Make sure $per_page is a valid value
		$per_page = ($top <= 0) ? 1 : $top;

		if (($replies) > $per_page)
		{
			$total_pages = ceil(($replies + 1) / $per_page);
			$pagination = '';

			$times = 1;
			for ($j = 0; $j < $replies + 1; $j += $per_page)
			{
				$pagination .= '<a href="' . $url . '&amp;start=' . $j . '">' . $times . '</a>';
				if ($times == 1 && $total_pages > 5)
				{
					$pagination .= ' ... ';

					// Display the last three pages
					$times = $total_pages - 3;
					$j += ($total_pages - 4) * $per_page;
				}
				else if ($times < $total_pages)
				{
					$pagination .= '<span class="page-sep">' . $user->lang['COMMA_SEPARATOR'] . '</span>';
				}
				$times++;
			}
		}
		else
		{
			$pagination = '1';
		}

		return $pagination;
	}

}

?>