<?php
/**
*
* @package acp
* @version $Id: acp_groups_ranks.php 2009-01-08 Thonaute $
* @copyright (c) 2005 phpBB Group, 2009 Thonaute
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_groups_ranks
{
	var $u_action;

	function main($id, $mode)
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;

		$user->add_lang('acp/permissions');

		// Set up general vars
		$action = request_var('action', '');
		$group_id = request_var('group', 0);
		$rank_id = request_var('rank', 0);

		$this->tpl_name = 'acp_groups_ranks';
		$this->page_title = 'ACP_GROUPS_RANKS';
		
		if($group_id == 0)
		{
			$template->assign_vars(array(
				'S_SELECT_GROUP'		=> true,
				'S_GROUP_OPTIONS'		=> group_select_options(false, false, false), // Show all groups
				
				'U_ACTION'				=> $this->u_action)
			);
		}
		else
		{
			$user->add_lang('acp/posting');
			
			$form_name = 'acp_ranks';
			add_form_key($form_name);
			
			//Group name
			$sql = 'SELECT group_name, group_type
				FROM ' . GROUPS_TABLE . '
				WHERE group_id = ' . $group_id;
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);
			
			$group_name = ($row['group_type'] == GROUP_SPECIAL) ? $user->lang['G_' . $row['group_name']] : $row['group_name'];		
			
			switch ($action)
			{
				case 'save':
					
					if (!check_form_key($form_name))
					{
						trigger_error($user->lang['FORM_INVALID']. adm_back_link($this->u_action), E_USER_WARNING);
					}
					$rank_title = utf8_normalize_nfc(request_var('title', '', true));
					$rank_image = request_var('rank_image', '');

					// The rank image has to be a jpg, gif or png
					if ($rank_image != '' && !preg_match('#(\.gif|\.png|\.jpg|\.jpeg)$#i', $rank_image))
					{
						$rank_image = '';
					}


					//DELETE + INSERT
					$sql = 'DELETE FROM ' . GROUPS_RANKS_TABLE . "
							WHERE group_id = $group_id
								AND rank_id = $rank_id";
					$db->sql_query($sql);


					if($rank_title != '')
					{
						$sql_ary = array(
							'group_id'			=> $group_id,
							'rank_id'			=> $rank_id,
							'group_rank_title'	=> $rank_title,
							'group_rank_image'	=> htmlspecialchars_decode($rank_image)
						);
						
						$sql = 'INSERT INTO ' . GROUPS_RANKS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
						$db->sql_query($sql);
					}

//					add_log('admin', 'LOG_RANK_UPDATED', $rank_title);
					$message = $user->lang['RANK_UPDATED'];
					trigger_error($message . adm_back_link($this->u_action));

					return;
				break;
				
				case 'edit':
				
					$data = $ranks = $existing_imgs = array();
					
					$sql = 'SELECT r.*, gr.group_rank_title, gr.group_rank_image
						FROM ' . RANKS_TABLE . ' r
						LEFT JOIN ' . GROUPS_RANKS_TABLE . ' gr ON (gr.rank_id = r.rank_id 
																AND gr.group_id = ' . $group_id . ')
						WHERE r.rank_id =' .$rank_id;
					$result = $db->sql_query($sql);					

					$ranks = $db->sql_fetchrow($result);
					$db->sql_freeresult($result);

					$imglist = filelist($phpbb_root_path . $config['ranks_path'], '');
					$edit_img = $filename_list = '';

					foreach ($imglist as $path => $img_ary)
					{
						sort($img_ary);

						foreach ($img_ary as $img)
						{
							$img = $path . $img;

							if ($img == $ranks['group_rank_image'])
							{
								$selected = ' selected="selected"';
								$edit_img = $img;
							}
							else
							{
								$selected = '';
							}

							if (strlen($img) > 255)
							{
								continue;
							}

							$filename_list .= '<option value="' . htmlspecialchars($img) . '"' . $selected . '>' . $img . '</option>';
						}
					}

					$filename_list = '<option value=""' . (($edit_img == '') ? ' selected="selected"' : '') . '>----------</option>' . $filename_list;
					unset($existing_imgs, $imglist);

					$template->assign_vars(array(
						'S_EDIT'			=> true,
						'S_FILENAME_LIST'	=> $filename_list,
						'S_SPECIAL_RANK'	=> (!isset($ranks['rank_special']) || $ranks['rank_special']) ? true : false,
						
						'U_BACK'			=> $this->u_action . '&amp;group=' . $group_id,
						'U_ACTION'			=> $this->u_action . '&amp;action=save&amp;group=' . $group_id . '&amp;rank=' . $rank_id,

						'RANKS_PATH'		=> $phpbb_root_path . $config['ranks_path'],
						'RANK_TITLE'		=> (isset($ranks['rank_title'])) ? $ranks['rank_title'] : '',
						'GROUP_RANK_TITLE'	=> (isset($ranks['rank_title'])) ? $ranks['group_rank_title'] : '',
						'RANK_IMAGE'		=> ($ranks['rank_image']) ? $phpbb_root_path . $config['ranks_path'] . '/' . $ranks['rank_image'] : $phpbb_admin_path . 'images/spacer.gif',
						'GROUP_RANK_IMAGE'	=> ($edit_img) ? $phpbb_root_path . $config['ranks_path'] . '/' . $edit_img : $phpbb_admin_path . 'images/spacer.gif',
						'MIN_POSTS'			=> (isset($ranks['rank_min']) && !$ranks['rank_special']) ? $ranks['rank_min'] : 0,
						'GROUP_NAME'		=> $group_name)
					);
							

					return;
				break;
			}
			
			$template->assign_vars(array(
				'S_SELECT_RANK'		=> true,
				'U_BACK'			=> $this->u_action,				
				'GROUP_NAME'		=> $group_name)
			);

			$sql = 'SELECT r.*, gr.group_rank_title, gr.group_rank_image
				FROM ' . RANKS_TABLE . ' r
				LEFT JOIN ' . GROUPS_RANKS_TABLE . ' gr ON (gr.rank_id = r.rank_id 
														AND gr.group_id = ' . $group_id . ')
				ORDER BY r.rank_special DESC, r.rank_min ASC, r.rank_title ASC';
			$result = $db->sql_query($sql);

			while ($row = $db->sql_fetchrow($result))
			{
				$template->assign_block_vars('ranks', array(
					'S_RANK_IMAGE'		=> ($row['rank_image']) ? true : false,
					'S_GROUP_RANK_IMAGE'=> ($row['group_rank_image']) ? true : false,
					'S_SPECIAL_RANK'	=> ($row['rank_special']) ? true : false,

					'U_EDIT'			=> $this->u_action . '&amp;action=edit&amp;group=' . $group_id . '&amp;rank=' . $row['rank_id'],
					
					'RANK_IMAGE'		=> $phpbb_root_path . $config['ranks_path'] . '/' . $row['rank_image'],
					'GROUP_RANK_IMAGE'	=> $phpbb_root_path . $config['ranks_path'] . '/' . $row['group_rank_image'],
					'RANK_TITLE'		=> $row['rank_title'],
					'GROUP_RANK_TITLE'	=> $row['group_rank_title'],
					'MIN_POSTS'			=> $row['rank_min'])
				);	
			}
			$db->sql_freeresult($result);			
		}

	}
}

?>